'use strict';

exports.__esModule = true;

var _css = require('antd/lib/modal/style/css');

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Api = function () {
    Api.prototype.post = function post(url, data) {
        return this._base.post(url, _qs2.default.stringify(data)).catch(function (error) {
            var message = '系统错误';
            if (error.response) {
                message = error.response.data.message;
            } else if (error.request) {
                message = error.request;
            } else {
                message = error.message;
            };
            _modal2.default.error({
                title: '系统提示',
                content: message
            });
        });
    };

    Api.prototype.get = function get(url, data) {
        return this._base.get(url, { params: data }).catch(function (error) {
            var message = '系统错误';
            if (error.response) {
                message = error.response.data.message;
            } else if (error.request) {
                message = error.request;
            } else {
                message = error.message;
            };
            _modal2.default.error({
                title: '系统提示',
                content: message
            });
        });
    };

    function Api(_ref) {
        var _this = this;

        var _ref$baseUrl = _ref.baseUrl,
            baseUrl = _ref$baseUrl === undefined ? '' : _ref$baseUrl,
            _ref$apis = _ref.apis,
            apis = _ref$apis === undefined ? {} : _ref$apis;

        _classCallCheck(this, Api);

        this._axios = _axios2.default;

        this._base = _axios2.default.create({
            baseURL: baseUrl
        });

        var _loop = function _loop(key) {
            if (apis[key].mode === 'get') {
                _this[key] = function () {
                    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                    return _this.get(apis[key].url, data);
                };
            } else {
                _this[key] = function () {
                    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                    return _this.post(apis[key].url, data);
                };
            };
        };

        for (var key in apis) {
            _loop(key);
        };
    }

    return Api;
}();

exports.default = Api;
;