'use strict';

exports.__esModule = true;

var _mobx = require('mobx');

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BaseModel = function () {
    return function () {
        function _class(_config) {
            var _this = this;

            _classCallCheck(this, _class);

            var _options = {};

            var _loop = function _loop(key) {
                if (key === 'namespace') {
                    return 'continue';
                };
                if (key === 'actions') {
                    if ((0, _utils.isEmpty)(_config[key])) {
                        return 'continue';
                    };

                    var _loop2 = function _loop2(_action) {
                        _options[_action] = (0, _mobx.action)(function () {
                            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                                args[_key] = arguments[_key];
                            }

                            return _config[key][_action].apply(_this, [].concat(args));
                        });
                    };

                    for (var _action in _config[key]) {
                        _loop2(_action);
                    };
                    return 'continue';
                };
                _options[key] = _config[key];
            };

            for (var key in _config) {
                var _ret = _loop(key);

                if (_ret === 'continue') continue;
            };

            (0, _mobx.extendObservable)(this, _options);
        }

        _class.prototype.getQuery = function getQuery() {
            var _search = window.location.search;
            if (!/^\?/.test(_search)) {
                return void 0;
            }
            var _queryString = _search.split('?')[1];
            return _qs2.default.parse(_queryString);
        };

        return _class;
    }();
}();

exports.default = BaseModel;