'use strict';

exports.__esModule = true;
exports.FormViewDesign = exports.InputWarp = undefined;

var _css = require('antd/lib/popover/style/css');

var _popover = require('antd/lib/popover');

var _popover2 = _interopRequireDefault(_popover);

var _css2 = require('antd/lib/button/style/css');

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _css3 = require('antd/lib/radio/style/css');

var _radio = require('antd/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

var _css4 = require('antd/lib/tree/style/css');

var _tree = require('antd/lib/tree');

var _tree2 = _interopRequireDefault(_tree);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _FieldDesignModel = require('./FieldDesignModel');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreeNode = _tree2.default.TreeNode;

var RadioGroup = _radio2.default.Group;

var InputWarp = exports.InputWarp = function (_React$Component) {
    _inherits(InputWarp, _React$Component);

    function InputWarp() {
        _classCallCheck(this, InputWarp);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    InputWarp.prototype.render = function render() {
        var label = this.props.label;

        return React.createElement(
            'div',
            {
                style: {
                    display: 'table',
                    width: '100%',
                    padding: '8px 0'
                }
            },
            React.createElement(
                'div',
                {
                    style: {
                        display: 'table-cell',
                        textAlign: 'right'
                    }
                },
                React.createElement(
                    'span',
                    {
                        style: {
                            fontSize: '12px',
                            color: '#333'
                        }
                    },
                    label
                )
            ),
            React.createElement(
                'div',
                {
                    style: {
                        display: 'table-cell',
                        width: '200px',
                        paddingLeft: '10px'
                    }
                },
                this.props.children
            )
        );
    };

    return InputWarp;
}(React.Component);

;

var FormViewDesign = exports.FormViewDesign = function (_React$Component2) {
    _inherits(FormViewDesign, _React$Component2);

    function FormViewDesign() {
        _classCallCheck(this, FormViewDesign);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    FormViewDesign.prototype.render = function render() {
        var _props = this.props,
            data = _props.data,
            getName = _props.getName,
            addNode = _props.addNode,
            deleteNode = _props.deleteNode;

        var loop = function loop(data) {
            return data.map(function (item, i) {
                var title = void 0;
                switch (item.type) {
                    case _FieldDesignModel.design_types.ROW:
                        title = '行';
                        break;
                    case _FieldDesignModel.design_types.COLUMN:
                        title = '列';
                        break;
                    case _FieldDesignModel.design_types.PAGE:
                        title = '表';
                        break;
                    case _FieldDesignModel.design_types.SPACE:
                        title = '空';
                        break;
                    default:
                        title = '行';
                        break;
                };

                var _view = function _view(key) {
                    return React.createElement(
                        'p',
                        {
                            style: {
                                paddingLeft: "4px"
                            }
                        },
                        React.createElement(
                            'span',
                            null,
                            title,
                            item.children.length ? '( ' + item.children.length + ' )' : void 0
                        ),
                        item.type === _FieldDesignModel.design_types.COLUMN ? void 0 : React.createElement(AddRowComponent, { onOk: addNode, id: key, type: item.type }),
                        React.createElement(
                            'span',
                            {
                                style: {
                                    marginLeft: item.type === _FieldDesignModel.design_types.COLUMN ? '24px' : '8px'
                                }
                            },
                            React.createElement(_button2.default, {
                                type: 'danger',
                                size: 'small',
                                shape: 'circle',
                                icon: 'delete',
                                disabled: item.disabled,
                                onClick: function onClick() {
                                    return deleteNode(key);
                                }
                            })
                        )
                    );
                };
                if (item.children && item.children.length) {
                    return React.createElement(
                        TreeNode,
                        { key: item.key, title: _view(item.key) },
                        loop(item.children)
                    );
                };
                return React.createElement(TreeNode, { key: item.key, title: _view(item.key) });
            });
        };
        return React.createElement(
            'div',
            null,
            React.createElement(
                _tree2.default,
                {
                    style: { width: '100%' }
                    //draggable
                    , showLine: true,
                    defaultExpandAll: true
                },
                loop(data)
            )
        );
    };

    return FormViewDesign;
}(React.Component);

;

var AddRowComponent = function (_React$Component3) {
    _inherits(AddRowComponent, _React$Component3);

    function AddRowComponent(props) {
        _classCallCheck(this, AddRowComponent);

        var _this3 = _possibleConstructorReturn(this, _React$Component3.call(this, props));

        _this3.state = {
            type: props.type === _FieldDesignModel.design_types.ROW ? _FieldDesignModel.design_types.COLUMN : _FieldDesignModel.design_types.ROW,
            visible: false,
            position: _FieldDesignModel.title_position.TOP
        };
        return _this3;
    }

    AddRowComponent.prototype.render = function render() {
        var _this4 = this;

        var type = this.props.type;

        return React.createElement(
            'span',
            {
                style: {
                    marginLeft: '24px'
                }
                //onClick={() => addNode( key )}
            },
            React.createElement(_button2.default, {
                size: 'small',
                shape: 'circle',
                icon: 'file-add',
                onClick: function onClick() {
                    _this4.setState({ visible: !_this4.state.visible });
                }
            }),
            React.createElement(_popover2.default, {
                placement: 'bottom',
                title: '\u6DFB\u52A0',
                trigger: 'click',
                visible: this.state.visible,
                content: React.createElement(
                    'div',
                    {
                        style: { margin: '0 -16px' }
                    },
                    React.createElement(
                        'div',
                        {
                            style: { padding: '0 16px' }
                        },
                        React.createElement(
                            RadioGroup,
                            {
                                value: this.state.type,
                                onChange: function onChange(e) {
                                    return _this4.setState({ type: e.target.value });
                                }
                            },
                            React.createElement(
                                _radio2.default,
                                { value: _FieldDesignModel.design_types.COLUMN, disabled: type !== _FieldDesignModel.design_types.ROW },
                                '\u5217'
                            ),
                            React.createElement(
                                _radio2.default,
                                { value: _FieldDesignModel.design_types.ROW },
                                '\u884C'
                            ),
                            React.createElement(
                                _radio2.default,
                                { value: _FieldDesignModel.design_types.PAGE },
                                '\u8868'
                            ),
                            React.createElement(
                                _radio2.default,
                                { value: _FieldDesignModel.design_types.SPACE },
                                '\u7A7A'
                            )
                        ),
                        this.state.type === _FieldDesignModel.design_types.PAGE ? React.createElement(
                            'div',
                            {
                                style: { marginTop: '8px', paddingTop: '8px', borderTop: '1px solid #ddd' }
                            },
                            React.createElement(
                                'span',
                                { style: { marginRight: '8px' } },
                                '\u6807\u9898\u4F4D\u7F6E'
                            ),
                            React.createElement(
                                RadioGroup,
                                {
                                    value: this.state.position,
                                    onChange: function onChange(e) {
                                        return _this4.setState({ position: e.target.value });
                                    }
                                },
                                React.createElement(
                                    _radio2.default,
                                    { value: _FieldDesignModel.title_position.TOP },
                                    '\u4E0A'
                                ),
                                React.createElement(
                                    _radio2.default,
                                    { value: _FieldDesignModel.title_position.LEFT },
                                    '\u5DE6'
                                )
                            )
                        ) : void 0
                    ),
                    React.createElement(
                        'div',
                        {
                            style: {
                                marginTop: '8px',
                                padding: '0 16px',
                                paddingTop: '8px',
                                overflow: 'hidden',
                                borderTop: '1px solid #ddd'
                            }
                        },
                        React.createElement(
                            'div',
                            {
                                style: { float: 'right' }
                            },
                            React.createElement(
                                _button2.default,
                                {
                                    size: 'small',
                                    style: { marginRight: '8px' },
                                    onClick: function onClick() {
                                        return _this4.setState({ visible: false, type: _FieldDesignModel.design_types.COLUMN, position: _FieldDesignModel.title_position.TOP });
                                    }
                                },
                                '\u53D6\u6D88'
                            ),
                            React.createElement(
                                _button2.default,
                                {
                                    size: 'small',
                                    type: 'primary',
                                    onClick: function onClick() {
                                        _this4.props.onOk(_this4.props.id, _this4.state.type, _this4.state.position);
                                        _this4.setState({ visible: false, type: _FieldDesignModel.design_types.COLUMN, position: _FieldDesignModel.title_position.TOP });
                                    }
                                },
                                '\u786E\u5B9A'
                            )
                        )
                    )
                )
            })
        );
    };

    return AddRowComponent;
}(React.Component);

;