'use strict';

exports.__esModule = true;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

var _FieldDesignModel = require('./FieldDesignModel');

var _FieldView = require('./FieldView');

var _FieldView2 = _interopRequireDefault(_FieldView);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldContent = (0, _mobxReact.inject)('crfDesign', 'crfFormEdit')((0, _mobxReact.observer)(function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    _class.prototype.componentWillMount = function componentWillMount() {
        var _props = this.props,
            name = _props.name,
            headerStyle = _props.headerStyle;

        this.props.crfDesign.init({
            name: name,
            headerStyle: headerStyle
        });
    };

    _class.prototype.render = function render() {
        var _props$crfDesign = this.props.crfDesign,
            formName = _props$crfDesign.formName,
            headerStyle = _props$crfDesign.headerStyle,
            design = _props$crfDesign.design,
            setCellPosition = _props$crfDesign.setCellPosition,
            getField = _props$crfDesign.getField;
        var isDrag = this.props.crfFormEdit.isDrag;
        var width = this.props.width;

        var _view = function _view(col) {
            return col.map(function (item, i) {
                var _className = 'crf-design-' + item.type;
                if (item.children && item.children.length) {
                    if (item.type === _FieldDesignModel.design_types.PAGE) {
                        return React.createElement(
                            'div',
                            { className: _className + ' ' + item.titlePosition },
                            React.createElement('div', null),
                            React.createElement(
                                'div',
                                null,
                                React.createElement(
                                    'div',
                                    { className: 'crf-design-table' },
                                    _view(item.children)
                                )
                            )
                        );
                    };
                    return React.createElement(
                        'div',
                        { className: _className, key: item.key },
                        _view(item.children)
                    );
                };
                if (item.type === _FieldDesignModel.design_types.SPACE) {
                    return React.createElement('div', { className: _className, style: item.spaceNoBorder ? { border: '0 none' } : void 0 });
                };
                return React.createElement(Cell, {
                    width: (width - 32) / col.length + 'px',
                    className: _className,
                    key: item.key,
                    item: item,
                    index: i,
                    last: col.length - 1,
                    isDrag: isDrag,
                    getField: getField,
                    setCellPosition: setCellPosition
                });
            });
        };
        return React.createElement(
            'div',
            { className: 'crf-field-container' },
            React.createElement(
                'div',
                { className: 'field-header' },
                React.createElement(
                    'h4',
                    {
                        style: headerStyle
                    },
                    formName
                )
            ),
            React.createElement(
                'div',
                { className: 'crf-design-table' },
                React.createElement('div', { style: { height: 0, width: '100%', borderBottom: '2px dashed #ddd' } }),
                _view(design)
            )
        );
    };

    return _class;
}(React.Component)));

var Cell = function (_React$Component2) {
    _inherits(Cell, _React$Component2);

    function Cell() {
        _classCallCheck(this, Cell);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    Cell.prototype.componentDidMount = function componentDidMount() {
        this.props.setCellPosition(this.props.item.key, this._cell);
    };

    Cell.prototype.componentWillUpdate = function componentWillUpdate(nextProps) {
        if (this.props.isDrag !== nextProps.isDrag && nextProps.isDrag) {
            this.props.setCellPosition(this.props.item.key, this._cell);
        }
    };

    Cell.prototype.render = function render() {
        var _this3 = this;

        var _props$item = this.props.item,
            elementInit = _props$item.elementInit,
            field_id = _props$item.field_id;
        var _props2 = this.props,
            className = _props2.className,
            getField = _props2.getField,
            width = _props2.width,
            index = _props2.index,
            last = _props2.last;

        var store = void 0,
            view = void 0;
        if (!(0, _utils.isUndefined)(field_id)) {
            var _model = getField(field_id);
            store = _model.store;
            view = _model.view;
        }
        return React.createElement(
            'div',
            {
                className: className,
                style: Object.assign({}, { width: width, verticalAlign: 'top' }, elementInit ? { backgroundColor: 'rgba(250, 250, 250, 1)' } : void 0)
            },
            React.createElement(
                'div',
                { ref: function ref(_cell) {
                        return _this3._cell = _cell;
                    }, style: { position: 'relative', minHeight: (0, _utils.isUndefined)(field_id) ? '80px' : 0 } },
                index !== last ? React.createElement(
                    'div',
                    { className: 'right-line' },
                    React.createElement('input', null)
                ) : void 0,
                (0, _utils.isUndefined)(field_id) ? void 0 : React.createElement(_FieldView2.default, {
                    store: store,
                    SubView: view,
                    disabled: true,
                    mode: 'DEV'
                })
            )
        );
    };

    return Cell;
}(React.Component);

;

exports.default = FieldContent;