'use strict';

exports.__esModule = true;

var _css = require('antd/lib/popover/style/css');

var _popover = require('antd/lib/popover');

var _popover2 = _interopRequireDefault(_popover);

var _css2 = require('antd/lib/icon/style/css');

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _css3 = require('antd/lib/radio/style/css');

var _radio = require('antd/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

var _reactGridLayout = require('react-grid-layout');

var _reactGridLayout2 = _interopRequireDefault(_reactGridLayout);

var _utils = require('../utils');

var _FieldView = require('./FieldView');

var _FieldView2 = _interopRequireDefault(_FieldView);

require('react-grid-layout/css/styles.css');

var _FieldSetting = require('./FieldSetting');

var _FieldSetting2 = _interopRequireDefault(_FieldSetting);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//const ResponsiveReactGridLayout = WidthProvider(Responsive);

var RadioGroup = _radio2.default.Group;

var FieldContent = (0, _mobxReact.inject)('crfDesign')((0, _mobxReact.observer)(function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class(props) {
        _classCallCheck(this, _class);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            width: 0
        };
        return _this;
    }

    _class.prototype.componentWillMount = function componentWillMount() {
        var _props = this.props,
            name = _props.name,
            headerStyle = _props.headerStyle;

        this.props.crfDesign.init({
            name: name,
            headerStyle: headerStyle
        });
    };

    _class.prototype.componentDidMount = function componentDidMount() {
        this.setState({ width: this._content.clientWidth });
    };

    _class.prototype.render = function render() {
        var _this2 = this;

        var _props$crfDesign = this.props.crfDesign,
            formName = _props$crfDesign.formName,
            headerStyle = _props$crfDesign.headerStyle,
            layouts = _props$crfDesign.layouts,
            getField = _props$crfDesign.getField,
            layoutsChange = _props$crfDesign.layoutsChange,
            setCellNode = _props$crfDesign.setCellNode,
            setCellPosition = _props$crfDesign.setCellPosition,
            deleteCell = _props$crfDesign.deleteCell,
            fieldsCollection = _props$crfDesign.fieldsCollection,
            changeFieldCollection = _props$crfDesign.changeFieldCollection,
            changeCellContentVertical = _props$crfDesign.changeCellContentVertical,
            border = _props$crfDesign.border,
            addRelation = _props$crfDesign.addRelation,
            is_static = _props$crfDesign.is_static;
        var mode = this.props.mode;

        return React.createElement(
            'div',
            { className: 'crf-field-container' },
            React.createElement(
                'div',
                { className: 'field-header' },
                React.createElement(
                    'h4',
                    {
                        style: headerStyle
                    },
                    formName
                )
            ),
            React.createElement(
                'div',
                {
                    ref: function ref(content) {
                        return _this2._content = content;
                    }
                },
                React.createElement(
                    _reactGridLayout2.default,
                    {
                        className: 'layout',
                        style: { backgroundColor: border.show ? border.color : 'transparent' },
                        cols: 12,
                        rowHeight: 12,
                        margin: [2, 2],
                        width: this.state.width //this._content ? this._content.clientWidth : void 0}
                        , onLayoutChange: function onLayoutChange(layout) {
                            return layoutsChange(layout);
                        }
                        //onDragStop={ layout => layoutsChange(layout) }
                        //onResizeStop={ layout => layoutsChange(layout) }
                    },
                    layouts.map(function (item) {
                        if (mode !== 'DEV' || is_static) {
                            item.layout.static = true;
                        };
                        return React.createElement(
                            'div',
                            {
                                key: item.key,
                                'data-grid': item.layout,
                                style: item.style
                            },
                            React.createElement(Cell, {
                                verticalAlign: item.cellVertical,
                                index: item.key,
                                setCellNode: setCellNode,
                                width: _this2.state.width //this._content ? this._content.clientWidth : void 0 }
                                , setCellPosition: setCellPosition,
                                le: layouts.length,
                                getField: getField,
                                field_id: item.field_id,
                                mode: mode,
                                deleteCell: deleteCell,
                                fieldsCollection: fieldsCollection,
                                changeFieldCollection: changeFieldCollection,
                                changeCellContentVertical: changeCellContentVertical,
                                addRelation: addRelation
                            })
                        );
                    })
                )
            )
        );
    };

    return _class;
}(React.Component)));

var Cell = function (_React$Component2) {
    _inherits(Cell, _React$Component2);

    function Cell() {
        _classCallCheck(this, Cell);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    Cell.prototype.componentDidMount = function componentDidMount() {
        if (this.props.mode === 'DEV') {
            this.props.setCellNode(this.props.index, this._cell);
        }
    };

    Cell.prototype.componentWillUpdate = function componentWillUpdate(nextProps) {
        if (this.props.mode === 'DEV' && (this.props.width !== nextProps.width || this.props.le !== nextProps.le)) {
            this.props.setCellPosition(this.props.index);
        }
    };

    Cell.prototype.render = function render() {
        var _this4 = this;

        var _props2 = this.props,
            getField = _props2.getField,
            field_id = _props2.field_id,
            mode = _props2.mode,
            index = _props2.index,
            deleteCell = _props2.deleteCell,
            fieldsCollection = _props2.fieldsCollection,
            changeFieldCollection = _props2.changeFieldCollection,
            verticalAlign = _props2.verticalAlign,
            changeCellContentVertical = _props2.changeCellContentVertical,
            addRelation = _props2.addRelation;

        var store = void 0,
            view = void 0;
        if (!(0, _utils.isEmpty)(field_id)) {
            var _model = getField(field_id);
            store = _model.store;
            view = _model.view;
        }
        return React.createElement(
            'div',
            {
                style: { width: "100%", height: '100%', overflow: 'auto', position: 'relative' },
                ref: function ref(cell) {
                    return _this4._cell = cell;
                },
                onMouseDown: function onMouseDown() {
                    return addRelation(field_id);
                }
            },
            mode === 'DEV' ? React.createElement(
                'div',
                {
                    className: 'crf-cell-edit-btns',
                    style: { width: (0, _utils.isEmpty)(field_id) ? '50px' : '75px' }
                },
                (0, _utils.isEmpty)(field_id) ? void 0 : React.createElement(_FieldSetting2.default, { store: store, onChange: function onChange(value) {
                        return changeFieldCollection(field_id, value);
                    } }),
                React.createElement(
                    _popover2.default,
                    {
                        placement: 'top',
                        trigger: 'click',
                        content: React.createElement(
                            'div',
                            null,
                            React.createElement(
                                RadioGroup,
                                {
                                    value: verticalAlign,
                                    onChange: function onChange(e) {
                                        return changeCellContentVertical(index, e.target.value);
                                    }
                                },
                                React.createElement(
                                    _radio2.default,
                                    { value: 'top' },
                                    '\u5C45\u4E0A'
                                ),
                                React.createElement(
                                    _radio2.default,
                                    { value: 'middle' },
                                    '\u5C45\u4E2D'
                                ),
                                React.createElement(
                                    _radio2.default,
                                    { value: 'bottom' },
                                    '\u5C45\u4E0B'
                                )
                            )
                        )
                    },
                    React.createElement(
                        'span',
                        null,
                        React.createElement(_icon2.default, { type: 'layout' })
                    )
                ),
                React.createElement(
                    'span',
                    {
                        onClick: function onClick() {
                            return deleteCell(index);
                        }
                    },
                    React.createElement(_icon2.default, { type: 'delete' })
                )
            ) : void 0,
            (0, _utils.isEmpty)(field_id) ? void 0 : React.createElement(
                'div',
                { style: { display: 'table', width: '100%', height: '100%' } },
                React.createElement(
                    'div',
                    { style: { display: 'table-cell', verticalAlign: verticalAlign } },
                    React.createElement(_FieldView2.default, {
                        store: store,
                        SubView: view,
                        disabled: mode === 'DEV',
                        mode: mode,
                        onChange: function onChange(value) {
                            return changeFieldCollection(field_id, value);
                        }
                    })
                )
            )
        );
    };

    return Cell;
}(React.Component);

;

exports.default = FieldContent;