'use strict';

exports.__esModule = true;
exports.title_position = exports.design_types = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _mobx = require('mobx');

var _FormModel = require('./FormModel');

var _utils = require('../utils');

var _FieldModel = require('./FieldModel');

var _FormEditModel = require('./FormEditModel');

var _FormEditModel2 = _interopRequireDefault(_FormEditModel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var design_types = exports.design_types = {
    ROW: 'row',
    PAGE: 'page',
    SPACE: 'space',
    COLUMN: 'column'
};

var title_position = exports.title_position = {
    TOP: 'top',
    LEFT: 'left',
    RIGHT: 'right'
};

var FieldDesignModel = function (_BaseFormModel) {
    _inherits(FieldDesignModel, _BaseFormModel);

    function FieldDesignModel() {
        _classCallCheck(this, FieldDesignModel);

        var _this2 = _possibleConstructorReturn(this, _BaseFormModel.call(this));

        (0, _mobx.extendObservable)(_this2, {
            formName: '',
            selectKey: '',
            mainElement: null,
            design: [{
                type: design_types.ROW,
                key: '0',
                disabled: true,
                children: [{
                    type: design_types.COLUMN,
                    key: '0_0',
                    style: {
                        width: '100%',
                        borderLeft: '2px solid #ddd',
                        borderBottom: '2px solid #ddd',
                        borderRight: '2px solid #ddd'
                    },
                    disabled: true,
                    children: []
                }]
            }],
            fieldsCollection: [],
            headerStyle: {
                fontSize: '18px',
                textAlign: 'center',
                fontWeight: 400,
                color: '#333'
            },
            fields: [],
            init: (0, _mobx.action)(function (_ref) {
                var name = _ref.name,
                    headerStyle = _ref.headerStyle;

                //this.design = [ ];
                _this2.formName = name;
                if (headerStyle) {
                    _this2.headerStyle = Object.assign({}, _this2.headerStyle, headerStyle);
                }
            }),
            changeFormName: (0, _mobx.action)(function (name) {
                _this2.change = true;
                _this2.formName = name;
            }),
            changeHeaderStyle: (0, _mobx.action)(function (style) {
                _this2.change = true;
                _this2.headerStyle = Object.assign({}, _this2.headerStyle, style);
            }),
            setDesign: (0, _mobx.action)(function (design) {
                return _this2.design = design;
            }),
            addRow: (0, _mobx.action)(function (key, type, position) {
                _this2.change = true;
                var _design = (0, _utils.copy)(_this2.design);
                var _this = _this2.getParent(key, _design);
                var _parent = void 0,
                    _key = key;
                if (type === design_types.COLUMN) {
                    _parent = _this2.getParent(key, _design).children;
                } else {
                    var _keyArr = key.split('_');
                    _keyArr.splice(-1, 1);
                    _parent = _design;
                    _key = _keyArr.join('_');
                    if (_keyArr.length) {
                        _parent = _this2.getParent(_key, _design).children;
                    }
                }
                var _index = _parent.findIndex(function (item) {
                    return item.key === _this.key;
                });
                var _width = crfFormMain.page.width;
                console.log(_width);
                var _item = {
                    type: type,
                    key: '',
                    children: []
                };
                if (type == design_types.ROW) {
                    _item.children.push({
                        type: design_types.COLUMN,
                        key: '',
                        children: []
                    });
                };
                if (type === design_types.PAGE) {
                    _item.titlePosition = position;
                    _item.children.push({
                        type: design_types.ROW,
                        key: '',
                        children: [{
                            type: design_types.COLUMN,
                            key: '',
                            children: []
                        }]
                    });
                };
                if (type === design_types.COLUMN) {
                    _parent.push(_item);
                } else {
                    _parent.splice(_index + 1, 0, _item);
                };
                _this2.setKey(_design);
                _this2.setDesign(_design);
            }),
            deleteRow: (0, _mobx.action)(function (key) {
                _this2.change = true;
                var _design = (0, _utils.copy)(_this2.design);
                var _this = _this2.getParent(key, _design);
                var _keyArr = key.split('_');
                _keyArr.splice(-1, 1);
                var _parent = _design;
                if (_keyArr.length) {
                    _parent = _this2.getParent(_keyArr.join('_'), _design).children;
                }
                var _index = _parent.indexOf(_this);
                _parent.splice(_index, 1);
                _this2.setKey(_design);
                _this2.setDesign(_design);
            }),
            setCellPosition: (0, _mobx.action)(function (key, node) {
                var _pos = {
                    x: 0,
                    y: 0
                };
                _FormEditModel2.default.getOffeset(_pos, node);
                var _width = node.offsetWidth;
                var _Height = node.offsetHeight;
                var _area = {
                    x: {
                        min: _pos.x,
                        max: _pos.x + _width
                    },
                    y: {
                        min: _pos.y,
                        max: _pos.y + _Height
                    }
                };
                var _design = (0, _utils.copy)(_this2.design);
                var _parent = _this2.getParent(key, _design);
                _parent.area = _area;
                _this2.setDesign(_design);
            }),
            changeElementInit: (0, _mobx.action)(function (x, y, w, h) {
                _this2.selectKey = '';
                var _design = (0, _utils.copy)(_this2.design);
                var _tree = (0, _utils.treeToObj)(_design);
                var _top = _this2.mainElement.scrollTop;
                var _left = _this2.mainElement.scrollLeft;
                for (var key in _tree) {
                    if (_tree[key].type !== design_types.COLUMN) {
                        continue;
                    };
                    var _x = x >= _tree[key].area.x.min - _left && x <= _tree[key].area.x.max - _left;
                    var _y = y >= _tree[key].area.y.min - _top && y <= _tree[key].area.y.max - _top;
                    if (_x && _y) {
                        _this2.selectKey = key;
                    };
                    var _parent = crfDesign.getParent(key, _design);
                    _parent.elementInit = _x && _y;
                };
                _this2.setDesign(_design);
            }),
            setElementInitCancel: (0, _mobx.action)(function () {
                var _design = (0, _utils.copy)(_this2.design);
                var _tree = (0, _utils.treeToObj)(_design);
                for (var key in _tree) {
                    if (_tree[key].type !== design_types.COLUMN) {
                        continue;
                    };
                    var _parent = crfDesign.getParent(key, _design);
                    _parent.elementInit = false;
                };
                _this2.setDesign(_design);
            }),
            addField: (0, _mobx.action)(function (type) {
                if (_this2.selectKey === '') {
                    return void 0;
                };
                var _store = _FieldModel.mapType.getStore(type);
                _store.setFieldOption({ id: _this2.fieldsCollection.length });
                var _fields = (0, _utils.copy)(_this2.fieldsCollection);
                _fields.push(_store);
                _this2.fieldsCollection = _fields;
                var _design = (0, _utils.copy)(_this2.design);
                var _parent = _this2.getParent(_this2.selectKey, _design);
                _parent.field_id = _store.id;
                _this2.setDesign(_design);
            }),
            getField: function getField(id) {
                var _store = _this2.fieldsCollection.filter(function (item) {
                    return item.id === id;
                });
                return {
                    store: _store[0],
                    view: _FieldModel.mapType.getView(_store[0].type)
                };
            },
            setMainElement: (0, _mobx.action)(function (_el) {
                _this2.mainElement = _el;
            })
        });
        return _this2;
    }

    FieldDesignModel.prototype.getParent = function getParent(key, _design) {
        var _keys = key.split('_');
        var _parent = void 0;
        for (var i = 0; i < _keys.length; i++) {
            if (i === 0) {
                _parent = _design[_keys[i]];
            } else {
                _parent = _parent.children[_keys[i]];
            };
        };
        return _parent;
    };

    FieldDesignModel.prototype.setKey = function setKey(arr, k) {
        for (var i = 0; i < arr.length; i++) {
            var _key = i + '';
            if (!(0, _utils.isUndefined)(k)) {
                _key = k + '_' + i;
            };
            arr[i].spaceNoBorder = false;
            if (arr[i].type === design_types.SPACE && (i === arr.length - 1 || arr[i + 1].type === design_types.SPACE)) {
                arr[i].spaceNoBorder = true;
            };
            arr[i].disabled = false;
            if (arr.length === 1) {
                arr[i].disabled = true;
            };
            arr[i].key = _key;
            if (arr[i].children && arr[i].children.length) {
                this.setKey(arr[i].children, _key);
            };
        };
    };

    FieldDesignModel.prototype.fieldName = function fieldName(id) {
        var _field = this.fields.filter(function (item) {
            return item.id === id;
        });
        if (_field.length > 0) {
            return _field[0].label;
        };
        return '未定义';
    };

    _createClass(FieldDesignModel, [{
        key: 'fontSizeOptions',
        get: function get() {
            var _arr = [];
            for (var i = 12; i < 64; i++) {
                _arr.push(i);
            };
            return _arr;
        }
    }, {
        key: 'fontWeightOptions',
        get: function get() {
            return ['normal', '400', '500', '600', 'bold'];
        }
    }, {
        key: 'textAlignOptions',
        get: function get() {
            return [{
                value: 'left',
                label: '左'
            }, {
                value: 'center',
                label: '中'
            }, {
                value: 'right',
                label: '右'
            }];
        }
    }]);

    return FieldDesignModel;
}(_FormModel.BaseFormModel);

;

var crfDesign = new FieldDesignModel();

exports.default = crfDesign;