'use strict';

exports.__esModule = true;
exports.ValidateView = exports.SetOptionsView = exports.OptionsInlineView = exports.DescriptionView = exports.RequiredView = exports.InlineView = exports.ShowLabelView = exports.PlaceHolderView = exports.TitleView = exports.CodeView = undefined;

var _css = require('antd/lib/alert/style/css');

var _alert = require('antd/lib/alert');

var _alert2 = _interopRequireDefault(_alert);

var _css2 = require('antd/lib/message/style/css');

var _message = require('antd/lib/message');

var _message2 = _interopRequireDefault(_message);

var _css3 = require('antd/lib/button/style/css');

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _css4 = require('antd/lib/switch/style/css');

var _switch = require('antd/lib/switch');

var _switch2 = _interopRequireDefault(_switch);

var _css5 = require('antd/lib/input-number/style/css');

var _inputNumber = require('antd/lib/input-number');

var _inputNumber2 = _interopRequireDefault(_inputNumber);

var _css6 = require('antd/lib/input/style/css');

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _css7 = require('antd/lib/popover/style/css');

var _popover = require('antd/lib/popover');

var _popover2 = _interopRequireDefault(_popover);

var _css8 = require('antd/lib/icon/style/css');

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _css9 = require('antd/lib/radio/style/css');

var _radio = require('antd/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

var _reactGridLayout = require('react-grid-layout');

var _reactGridLayout2 = _interopRequireDefault(_reactGridLayout);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioGroup = _radio2.default.Group;

var FieldSettingView = function (_React$Component) {
    _inherits(FieldSettingView, _React$Component);

    function FieldSettingView() {
        _classCallCheck(this, FieldSettingView);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    FieldSettingView.prototype.render = function render() {
        var _this2 = this;

        var _props$store = this.props.store,
            settings = _props$store.settings,
            setting_title = _props$store.setting_title,
            setting_selected = _props$store.setting_selected;
        var onChange = this.props.onChange;

        var _title = React.createElement(
            'div',
            { style: { display: 'table', width: '100%' } },
            React.createElement(
                'div',
                {
                    style: {
                        display: 'table-cell',
                        width: 26 * setting_title.length + 4 + 'px',
                        overflow: 'hidden',
                        verticalAlign: 'top',
                        paddingRight: '4px'
                    }
                },
                setting_title.map(function (item) {
                    return React.createElement(
                        'div',
                        {
                            style: {
                                float: 'left',
                                width: '26px',
                                textAlign: "center",
                                padding: '4px 0'
                            },
                            key: item.type
                        },
                        React.createElement(
                            'a',
                            {
                                style: {
                                    display: 'block',
                                    width: '26px',
                                    margin: '0 auto',
                                    color: '#666',
                                    borderRadius: '2px',
                                    lineHeight: '24px',
                                    backgroundColor: item.type === setting_selected ? 'rgba(150, 150, 150, .2)' : 'transparent'
                                },
                                onClick: function onClick() {
                                    return onChange({ setting_selected: item.type });
                                }
                            },
                            React.createElement('i', { className: item.icon, style: { fontSize: '14px' } })
                        )
                    );
                })
            ),
            React.createElement(
                'div',
                {
                    style: {
                        display: 'table-cell'
                    }
                },
                React.createElement(
                    'p',
                    null,
                    setting_title.filter(function (item) {
                        return item.type === setting_selected;
                    })[0].label
                )
            )
        );
        var _content = React.createElement(
            'div',
            { style: { width: '240px', height: '180px', overflowY: 'scroll', marginRight: '-16px', paddingRight: '16px' } },
            settings[setting_selected].map(function (View, i) {
                return React.createElement(View, { key: i, store: _this2.props.store, onChange: onChange });
            })
        );
        return React.createElement(
            _popover2.default,
            {
                title: _title,
                content: _content,
                placement: 'left',
                arrowPointAtCenter: true,
                trigger: 'click'
            },
            React.createElement(
                'span',
                null,
                React.createElement(_icon2.default, { type: 'edit' })
            )
        );
    };

    return FieldSettingView;
}(React.Component);

;

var InputType = function (_React$Component2) {
    _inherits(InputType, _React$Component2);

    function InputType() {
        _classCallCheck(this, InputType);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    InputType.prototype.render = function render() {
        var _this4 = this;

        var _props = this.props,
            label = _props.label,
            store = _props.store,
            name = _props.name;

        return React.createElement(
            'div',
            { className: 'crf-setting-wrap' },
            React.createElement(
                'label',
                { className: 'setting-title' },
                label,
                ': '
            ),
            React.createElement(
                'div',
                {
                    className: 'setting-input'
                },
                React.createElement(_input2.default, {
                    value: store.getOptions(name),
                    onChange: function onChange(e) {
                        var _this4$props$onChange;

                        _this4.props.onChange((_this4$props$onChange = {}, _this4$props$onChange[name] = e.target.value, _this4$props$onChange));
                    }
                })
            )
        );
    };

    return InputType;
}(React.Component);

;

var NumberType = function (_React$Component3) {
    _inherits(NumberType, _React$Component3);

    function NumberType() {
        _classCallCheck(this, NumberType);

        return _possibleConstructorReturn(this, _React$Component3.apply(this, arguments));
    }

    NumberType.prototype.render = function render() {
        var _this6 = this;

        var _props2 = this.props,
            label = _props2.label,
            store = _props2.store,
            name = _props2.name;

        return React.createElement(
            'div',
            { className: 'crf-setting-wrap' },
            React.createElement(
                'label',
                { className: 'setting-title' },
                label,
                ': '
            ),
            React.createElement(
                'div',
                {
                    className: 'setting-input'
                },
                React.createElement(_inputNumber2.default, {
                    style: { width: "100%" },
                    value: store.getOptions(name),
                    onChange: function onChange(value) {
                        var _this6$props$onChange;

                        _this6.props.onChange((_this6$props$onChange = {}, _this6$props$onChange[name] = value, _this6$props$onChange));
                    }
                })
            )
        );
    };

    return NumberType;
}(React.Component);

;

var SwitchType = function (_React$Component4) {
    _inherits(SwitchType, _React$Component4);

    function SwitchType() {
        _classCallCheck(this, SwitchType);

        return _possibleConstructorReturn(this, _React$Component4.apply(this, arguments));
    }

    SwitchType.prototype.render = function render() {
        var _this8 = this;

        var _props3 = this.props,
            label = _props3.label,
            store = _props3.store,
            name = _props3.name,
            checkedLabel = _props3.checkedLabel,
            unCheckedLabel = _props3.unCheckedLabel;

        return React.createElement(
            'div',
            { className: 'crf-setting-wrap' },
            React.createElement(
                'label',
                { className: 'setting-title' },
                label,
                ': '
            ),
            React.createElement(
                'div',
                {
                    className: 'setting-input'
                },
                React.createElement(
                    'div',
                    { style: { float: 'left' } },
                    React.createElement(_switch2.default, {
                        checked: store.getOptions(name),
                        onChange: function onChange(checked) {
                            var _this8$props$onChange;

                            _this8.props.onChange((_this8$props$onChange = {}, _this8$props$onChange[name] = checked, _this8$props$onChange));
                        },
                        checkedChildren: checkedLabel || '是',
                        unCheckedChildren: unCheckedLabel || '否'
                    })
                )
            )
        );
    };

    return SwitchType;
}(React.Component);

;

var RadioType = function (_React$Component5) {
    _inherits(RadioType, _React$Component5);

    function RadioType() {
        _classCallCheck(this, RadioType);

        return _possibleConstructorReturn(this, _React$Component5.apply(this, arguments));
    }

    RadioType.prototype.render = function render() {
        var _this10 = this;

        var _props4 = this.props,
            label = _props4.label,
            store = _props4.store,
            name = _props4.name,
            options = _props4.options;

        var _value = void 0;
        switch (store.getOptions(name)) {
            case true:
                _value = 'true';
                break;
            case false:
                _value = 'false';
                break;
            default:
                _value = store.getOptions(name);
                break;
        };
        return React.createElement(
            'div',
            { className: 'crf-setting-wrap' },
            React.createElement(
                'label',
                { className: 'setting-title' },
                label,
                ': '
            ),
            React.createElement(
                'div',
                {
                    className: 'setting-input'
                },
                React.createElement(RadioGroup, {
                    value: _value,
                    options: options,
                    onChange: function onChange(e) {
                        var _this10$props$onChang;

                        var _val = void 0;
                        switch (e.target.value) {
                            case 'true':
                                _val = true;
                                break;
                            case 'false':
                                _val = false;
                                break;
                            default:
                                _val = e.target.value;
                                break;
                        };
                        _this10.props.onChange((_this10$props$onChang = {}, _this10$props$onChang[name] = _val, _this10$props$onChang));
                    }
                })
            )
        );
    };

    return RadioType;
}(React.Component);

;

var TextAreaType = function (_React$Component6) {
    _inherits(TextAreaType, _React$Component6);

    function TextAreaType() {
        _classCallCheck(this, TextAreaType);

        return _possibleConstructorReturn(this, _React$Component6.apply(this, arguments));
    }

    TextAreaType.prototype.render = function render() {
        var _this12 = this;

        var _props5 = this.props,
            label = _props5.label,
            store = _props5.store,
            name = _props5.name;

        return React.createElement(
            'div',
            { className: 'crf-setting-wrap' },
            React.createElement(
                'label',
                {
                    className: 'setting-title',
                    style: { verticalAlign: "top" }
                },
                label,
                ': '
            ),
            React.createElement(
                'div',
                {
                    className: 'setting-input'
                },
                React.createElement(_input2.default, {
                    type: 'textarea',
                    value: store.getOptions(name),
                    onChange: function onChange(e) {
                        var _this12$props$onChang;

                        _this12.props.onChange((_this12$props$onChang = {}, _this12$props$onChang[name] = e.target.value, _this12$props$onChang));
                    }
                })
            )
        );
    };

    return TextAreaType;
}(React.Component);

;

var SetOptionsType = function (_React$Component7) {
    _inherits(SetOptionsType, _React$Component7);

    function SetOptionsType() {
        _classCallCheck(this, SetOptionsType);

        return _possibleConstructorReturn(this, _React$Component7.apply(this, arguments));
    }

    SetOptionsType.prototype.render = function render() {
        var _props6 = this.props,
            label = _props6.label,
            store = _props6.store,
            name = _props6.name,
            _onChange3 = _props6.onChange;

        return React.createElement(
            'div',
            null,
            React.createElement(
                'div',
                { style: { paddingLeft: '5px', paddingBottom: '4px' } },
                label
            ),
            React.createElement(
                _reactGridLayout2.default,
                {
                    cols: 1,
                    rowHeight: 40,
                    margin: [2, 2],
                    width: 210,
                    onDragStop: function onDragStop(layout) {
                        var _onChange;

                        _onChange3((_onChange = {}, _onChange[name] = store.changeOptionsIndex(layout), _onChange));
                    }
                },
                store.getOptions(name).map(function (item, i) {
                    var _layouts = { x: 0, y: i, w: 1, h: 1, isResizable: false };
                    return React.createElement(
                        'div',
                        {
                            style: { backgroundColor: '#f0f0f0', paddingRight: '4px', paddingLeft: '2px', borderRadius: '2px' },
                            key: item.id,
                            'data-grid': _layouts

                        },
                        React.createElement(
                            'div',
                            { style: { display: 'table', width: '100%', height: '100%' } },
                            React.createElement(
                                'div',
                                { style: { display: 'table-cell', textAlign: 'center', cursor: 'pointer', width: '16px', verticalAlign: 'middle' } },
                                React.createElement('i', { style: { color: '#aaa' }, className: 'icon-more' })
                            ),
                            React.createElement(
                                'div',
                                { style: { display: 'table-cell', width: '34px', verticalAlign: 'middle', paddingRight: '2px' } },
                                React.createElement(_input2.default, {
                                    style: { textAlign: 'center' },
                                    value: item.code,
                                    onMouseDown: function onMouseDown(e) {
                                        return e.stopPropagation();
                                    },
                                    onChange: function onChange(e) {
                                        var _onChange2;

                                        _onChange3((_onChange2 = {}, _onChange2[name + '.' + i + '.code'] = e.target.value, _onChange2));
                                    }
                                })
                            ),
                            React.createElement(
                                'div',
                                { style: { display: 'table-cell', verticalAlign: 'middle', height: '100%' } },
                                React.createElement(_input2.default, {
                                    value: item.label,
                                    onMouseDown: function onMouseDown(e) {
                                        return e.stopPropagation();
                                    },
                                    onChange: function onChange(e) {
                                        var _onChange4;

                                        _onChange3((_onChange4 = {}, _onChange4[name + '.' + i + '.label'] = e.target.value, _onChange4));
                                    }
                                })
                            ),
                            React.createElement(
                                'div',
                                { style: { display: 'table-cell', paddingLeft: '2px', verticalAlign: 'middle', width: '24px' } },
                                React.createElement(_button2.default, {
                                    icon: 'plus',
                                    onMouseDown: function onMouseDown(e) {
                                        return e.stopPropagation();
                                    },
                                    onClick: function onClick() {
                                        var _onChange5;

                                        return _onChange3((_onChange5 = {}, _onChange5[name] = store.addOption(item.id), _onChange5));
                                    }
                                })
                            ),
                            React.createElement(
                                'div',
                                { style: { display: 'table-cell', paddingLeft: '2px', verticalAlign: 'middle', width: '24px' } },
                                React.createElement(_button2.default, {
                                    type: 'danger',
                                    icon: 'delete',
                                    onMouseDown: function onMouseDown(e) {
                                        return e.stopPropagation();
                                    },
                                    onClick: function onClick() {
                                        var _onChange6;

                                        if (store.getOptions(name).length < 2) {
                                            return _message2.default.error('选项不能少于一项！');
                                        };
                                        _onChange3((_onChange6 = {}, _onChange6[name] = store.deleteOption(item.id), _onChange6));
                                    }
                                })
                            )
                        )
                    );
                })
            )
        );
    };

    return SetOptionsType;
}(React.Component);

;

var CodeType = function (_React$Component8) {
    _inherits(CodeType, _React$Component8);

    function CodeType() {
        _classCallCheck(this, CodeType);

        return _possibleConstructorReturn(this, _React$Component8.apply(this, arguments));
    }

    CodeType.prototype.render = function render() {
        var _props7 = this.props,
            label = _props7.label,
            store = _props7.store,
            name = _props7.name,
            _onChange11 = _props7.onChange;

        return React.createElement(
            'div',
            null,
            React.createElement(
                'div',
                { className: 'crf-setting-wrap' },
                React.createElement(
                    'label',
                    { className: 'setting-title' },
                    label,
                    ':'
                ),
                React.createElement(
                    'div',
                    { className: 'setting-input' },
                    React.createElement(
                        _button2.default,
                        {
                            size: 'small',
                            type: 'danger',
                            icon: 'plus-square',
                            onClick: function onClick() {
                                var _onChange7;

                                return _onChange11((_onChange7 = {}, _onChange7[name] = store.addValidate('error'), _onChange7));
                            }
                        },
                        '\u9519\u8BEF'
                    ),
                    React.createElement(
                        _button2.default,
                        {
                            size: 'small',
                            style: { marginLeft: '8px' },
                            type: 'primary',
                            icon: 'plus-square',
                            onClick: function onClick() {
                                var _onChange8;

                                return _onChange11((_onChange8 = {}, _onChange8[name] = store.addValidate('warning'), _onChange8));
                            }
                        },
                        '\u63D0\u9192'
                    )
                )
            ),
            React.createElement(
                'div',
                null,
                store.validates.map(function (item, i) {
                    return React.createElement(ValidatorItem, {
                        item: item,
                        key: i,
                        index: i,
                        onChange: function onChange(key, value) {
                            var _onChange9;

                            _onChange11((_onChange9 = {}, _onChange9[name] = store.changeValidates(i, key, value), _onChange9));
                        },
                        onDelete: function onDelete() {
                            var _onChange10;

                            _onChange11((_onChange10 = {}, _onChange10[name] = store.deleteValidates(i), _onChange10));
                        }
                    });
                })
            )
        );
    };

    return CodeType;
}(React.Component);

;

var ValidatorItem = function (_React$Component9) {
    _inherits(ValidatorItem, _React$Component9);

    function ValidatorItem(prosp) {
        _classCallCheck(this, ValidatorItem);

        var _this15 = _possibleConstructorReturn(this, _React$Component9.call(this, prosp));

        _this15.state = {
            show: false
        };
        return _this15;
    }

    ValidatorItem.prototype.render = function render() {
        var _this16 = this;

        var _props8 = this.props,
            item = _props8.item,
            _onChange12 = _props8.onChange,
            onDelete = _props8.onDelete;

        return React.createElement(
            'div',
            null,
            React.createElement(_alert2.default, {
                style: { marginBottom: '8px' },
                message: React.createElement(
                    'p',
                    { style: { position: 'relative', minHeight: "16px" } },
                    React.createElement(
                        'span',
                        null,
                        item.message
                    ),
                    React.createElement(
                        'a',
                        {
                            style: { display: 'block', position: 'absolute', width: "16px", textAlign: 'center', right: "-12px", top: 0 },
                            onClick: function onClick() {
                                return _this16.setState({ show: !_this16.state.show });
                            }
                        },
                        React.createElement(_icon2.default, { type: this.state.show ? 'check' : 'edit' })
                    ),
                    React.createElement(
                        'a',
                        {
                            style: { display: 'block', position: 'absolute', width: "16px", textAlign: 'center', right: "-32px", top: 0, color: '#f04134' },
                            onClick: function onClick() {
                                return onDelete();
                            }
                        },
                        React.createElement(_icon2.default, { type: 'delete' })
                    )
                ),
                type: item.type
            }),
            this.state.show ? React.createElement(
                'div',
                { style: { padding: '8px', marginBottom: '8px', backgroundColor: '#f5f5f5', borderRadius: '2px' } },
                React.createElement(
                    RadioGroup,
                    { value: item.type, onChange: function onChange(e) {
                            return _onChange12('type', e.target.value);
                        } },
                    React.createElement(
                        _radio2.default,
                        { value: 'error' },
                        '\u9519\u8BEF'
                    ),
                    React.createElement(
                        _radio2.default,
                        { value: 'warning' },
                        '\u63D0\u9192'
                    )
                ),
                React.createElement(_input2.default, {
                    style: { margin: '4px 0' },
                    value: item.message,
                    placeholder: '\u9519\u8BEF\u63D0\u793A',
                    onChange: function onChange(e) {
                        return _onChange12('message', e.target.value);
                    }
                }),
                React.createElement(_input2.default, {
                    value: item.value,
                    placeholder: '\u8868\u8FBE\u5F0F',
                    type: 'textarea',
                    onChange: function onChange(e) {
                        return _onChange12('value', e.target.value);
                    }
                })
            ) : void 0
        );
    };

    return ValidatorItem;
}(React.Component);

;

exports.default = FieldSettingView;
var CodeView = exports.CodeView = function CodeView(props) {
    return React.createElement(NumberType, _extends({ label: '\u7F16\u53F7' }, props, { name: 'code' }));
};

var TitleView = exports.TitleView = function TitleView(props) {
    return React.createElement(InputType, _extends({ label: '\u6807\u9898' }, props, { name: 'label' }));
};

var PlaceHolderView = exports.PlaceHolderView = function PlaceHolderView(props) {
    return React.createElement(InputType, _extends({ label: '\u63D0\u793A' }, props, { name: 'placeholder' }));
};

var ShowLabelView = exports.ShowLabelView = function ShowLabelView(props) {
    return React.createElement(SwitchType, _extends({ label: '\u663E\u793A\u6807\u9898' }, props, { name: 'showLabel' }));
};

var InlineView = exports.InlineView = function InlineView(props) {
    return React.createElement(SwitchType, _extends({ label: '\u6C34\u5E73\u6392\u5217' }, props, { name: 'inline' }));
};

var RequiredView = exports.RequiredView = function RequiredView(props) {
    return React.createElement(SwitchType, _extends({ label: '\u5FC5\u586B' }, props, { name: 'required' }));
};

var DescriptionView = exports.DescriptionView = function DescriptionView(props) {
    return React.createElement(TextAreaType, _extends({ label: '\u5907\u6CE8' }, props, { name: 'field_options.description' }));
};

var OptionsInlineView = exports.OptionsInlineView = function OptionsInlineView(props) {
    return React.createElement(RadioType, _extends({
        label: '\u9009\u9879\u6392\u5217'
    }, props, {
        name: 'field_options.inline',
        options: [{ value: 'true', label: '水平' }, { value: 'false', label: '垂直' }]
    }));
};

var SetOptionsView = exports.SetOptionsView = function SetOptionsView(props) {
    return React.createElement(SetOptionsType, _extends({ label: '\u8BBE\u7F6E\u9009\u9879' }, props, { name: 'field_options.options' }));
};

var ValidateView = exports.ValidateView = function ValidateView(props) {
    return React.createElement(CodeType, _extends({ label: '\u903B\u8F91\u9A8C\u8BC1' }, props, { name: 'validates' }));
};