'use strict';

exports.__esModule = true;
exports.AutoCompleteView = exports.RadioView = exports.TextView = undefined;

var _css = require('antd/lib/input/style/css');

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _css2 = require('antd/lib/popover/style/css');

var _popover = require('antd/lib/popover');

var _popover2 = _interopRequireDefault(_popover);

var _css3 = require('antd/lib/mention/style/css');

var _mention = require('antd/lib/mention');

var _mention2 = _interopRequireDefault(_mention);

var _css4 = require('antd/lib/radio/style/css');

var _radio = require('antd/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioGroup = _radio2.default.Group;
var toString = _mention2.default.toString;

//import {Editor, EditorState, convertToRaw, convertFromRaw} from 'draft-js';

var FieldView = (0, _mobxReact.observer)(function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    _class.prototype.devView = function devView(store) {
        var settings = store.settings,
            setting_title = store.setting_title,
            setting_selected = store.setting_selected,
            changeSettingSelect = store.changeSettingSelect;

        var _title = React.createElement(
            'div',
            { style: { display: 'table', width: '100%' } },
            React.createElement(
                'div',
                {
                    style: {
                        display: 'table-cell',
                        width: 26 * setting_title.length + 4 + 'px',
                        overflow: 'hidden',
                        verticalAlign: 'top',
                        paddingRight: '4px'
                    }
                },
                setting_title.map(function (item) {
                    return React.createElement(
                        'div',
                        {
                            style: {
                                float: 'left',
                                width: '26px',
                                textAlign: "center",
                                padding: '4px 0'
                            },
                            key: item.type
                        },
                        React.createElement(
                            'a',
                            {
                                style: {
                                    display: 'block',
                                    width: '26px',
                                    margin: '0 auto',
                                    color: '#666',
                                    borderRadius: '2px',
                                    lineHeight: '24px',
                                    backgroundColor: item.type === setting_selected ? 'rgba(150, 150, 150, .2)' : 'transparent'
                                },
                                onClick: function onClick() {
                                    return changeSettingSelect(item.type);
                                }
                            },
                            React.createElement('i', { className: item.icon, style: { fontSize: '14px' } })
                        )
                    );
                })
            ),
            React.createElement(
                'div',
                {
                    style: {
                        display: 'table-cell'
                    }
                },
                React.createElement(
                    'p',
                    null,
                    setting_title.filter(function (item) {
                        return item.type === setting_selected;
                    })[0].label
                )
            )
        );
        var _content = React.createElement(
            'div',
            { style: { width: '240px', height: '180px', overflowY: 'scroll', marginRight: '-16px', paddingRight: '16px' } },
            settings[setting_selected].map(function (View, i) {
                return React.createElement(View, { key: i, store: store });
            })
        );
        return React.createElement(
            'div',
            {
                style: {
                    padding: '8px 4px'
                }
            },
            React.createElement(
                _popover2.default,
                {
                    title: _title,
                    content: _content,
                    placement: 'right',
                    arrowPointAtCenter: true,
                    trigger: 'click'
                },
                React.createElement(
                    'a',
                    { style: { fontSize: "13px" } },
                    '[ \u7F16\u8F91 ]'
                )
            )
        );
    };

    _class.prototype.render = function render() {
        var _this2 = this;

        var _props = this.props,
            store = _props.store,
            SubView = _props.SubView,
            disabled = _props.disabled,
            mode = _props.mode;
        var label = store.label,
            showLabel = store.showLabel,
            cid = store.cid,
            code = store.code,
            required = store.required,
            inline = store.inline,
            getOptions = store.getOptions;

        return React.createElement(
            'div',
            {
                style: { padding: '5px' }
            },
            React.createElement(
                'div',
                {
                    className: 'crf-field-content ' + (inline ? 'inline' : '')
                },
                showLabel ? React.createElement(
                    'div',
                    { className: 'field-label' },
                    React.createElement(
                        'label',
                        { htmlFor: '#' + cid },
                        required ? React.createElement(
                            'span',
                            { style: { color: '#ff2500' } },
                            ' * '
                        ) : void 0,
                        code,
                        ' - ',
                        label
                    )
                ) : void 0,
                React.createElement(
                    'div',
                    { className: 'field-content', style: showLabel ? void 0 : { paddingLeft: 0 } },
                    React.createElement(SubView, { store: store, disabled: disabled, onChange: function onChange(value) {
                            return _this2.props.onChange(value);
                        } })
                )
            ),
            getOptions('field_options.description') ? React.createElement(
                'div',
                {
                    style: {
                        borderBottom: '1px dashed #ccc',
                        borderTop: '1px dashed #ccc',
                        marginTop: '12px',
                        color: '#999',
                        fontSize: '14px',
                        lineHeight: '28px',
                        fontStyle: 'italic'
                    }
                },
                getOptions('field_options.description')
            ) : void 0
        );
    };

    return _class;
}(React.Component));

var TextView = exports.TextView = function (_React$Component2) {
    _inherits(TextView, _React$Component2);

    function TextView() {
        _classCallCheck(this, TextView);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    TextView.prototype.render = function render() {
        var _props$store = this.props.store,
            value = _props$store.value,
            placeholder = _props$store.placeholder,
            cid = _props$store.cid;
        var _props2 = this.props,
            disabled = _props2.disabled,
            _onChange = _props2.onChange;

        return React.createElement(
            'div',
            null,
            React.createElement(_input2.default, {
                disabled: disabled || this.props.store.disabled,
                id: cid,
                value: disabled ? "" : value,
                placeholder: placeholder,
                onChange: function onChange(e) {
                    return _onChange({ value: e.target.value });
                }
            })
        );
    };

    return TextView;
}(React.Component);

;

var RadioView = exports.RadioView = function (_React$Component3) {
    _inherits(RadioView, _React$Component3);

    function RadioView() {
        _classCallCheck(this, RadioView);

        return _possibleConstructorReturn(this, _React$Component3.apply(this, arguments));
    }

    RadioView.prototype.render = function render() {
        var _this5 = this;

        var _props$store2 = this.props.store,
            value = _props$store2.value,
            field_options = _props$store2.field_options;
        var _props3 = this.props,
            disabled = _props3.disabled,
            _onChange2 = _props3.onChange;
        var options = field_options.options,
            inline = field_options.inline;

        var _style = {
            display: 'block',
            height: '28px',
            lineHeight: '28px'
        };
        return React.createElement(
            'div',
            { style: { lineHeight: "28px" } },
            React.createElement(
                RadioGroup,
                {
                    value: disabled ? "" : value,
                    onChange: function onChange(e) {
                        return _onChange2({ value: e.target.value });
                    }
                },
                options.map(function (item) {
                    return React.createElement(
                        _radio2.default,
                        {
                            disabled: disabled || _this5.props.store.disabled,
                            value: item.code,
                            style: inline ? void 0 : _style,
                            key: item.code
                        },
                        item.label
                    );
                })
            )
        );
    };

    return RadioView;
}(React.Component);

;

var AutoCompleteView = exports.AutoCompleteView = function (_React$Component4) {
    _inherits(AutoCompleteView, _React$Component4);

    function AutoCompleteView() {
        _classCallCheck(this, AutoCompleteView);

        return _possibleConstructorReturn(this, _React$Component4.apply(this, arguments));
    }

    AutoCompleteView.prototype.render = function render() {
        var _props$store3 = this.props.store,
            _onSearchChange = _props$store3.onSearchChange,
            loading = _props$store3.loading,
            searchCodes = _props$store3.searchCodes;
        var disabled = this.props.disabled;

        return React.createElement(
            'div',
            null,
            React.createElement(_mention2.default, {
                style: { width: '100%', height: 100 },
                onChange: function onChange(editorState) {
                    //console.log(toString(editorState));
                },
                disabled: disabled || this.props.store.disabled,
                onSearchChange: function onSearchChange(value) {
                    return _onSearchChange(value);
                },
                loading: loading,
                suggestions: searchCodes.map(function (item) {
                    return item.name;
                }),
                multiLines: true
            })
        );
    };

    return AutoCompleteView;
}(React.Component);

;

exports.default = FieldView;

//  <Editor
// //handlePastedText = { (text, html) => console.log(text) }
//     //blockRendererFn={ block => console.log(block.getText()) }
//     editorState={this.state.editorState} 
//     onChange={this.onChange} 
// />