'use strict';

exports.__esModule = true;
exports.FormBuilder = undefined;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

var _SideBar = require('./SideBar');

var _SideBar2 = _interopRequireDefault(_SideBar);

require('./app.scss');

var _reactRouterDom = require('react-router-dom');

var _FormEdit = require('./FormEdit');

var _FormEdit2 = _interopRequireDefault(_FormEdit);

var _FormMainView = require('./FormMainView');

var _FormMainView2 = _interopRequireDefault(_FormMainView);

var _FieldModel = require('./FieldModel');

var _FieldView = require('./FieldView');

var _FieldView2 = _interopRequireDefault(_FieldView);

var _RelationView = require('./RelationView');

var _RelationView2 = _interopRequireDefault(_RelationView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormBuilder = exports.FormBuilder = (0, _mobxReact.inject)('crf', 'crfFormEdit', 'api')((0, _mobxReact.observer)(function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    _class.prototype.componentWillMount = function componentWillMount() {
        var formsApi = this.props.formsApi;

        this.props.crf.getForms(this.props.api[formsApi]);
    };

    _class.prototype.render = function render() {
        var _props$crf = this.props.crf,
            forms = _props$crf.forms,
            formsLoading = _props$crf.formsLoading;
        var _props = this.props,
            match = _props.match,
            location = _props.location;
        var _props$crfFormEdit = this.props.crfFormEdit,
            isDrag = _props$crfFormEdit.isDrag,
            dragTop = _props$crfFormEdit.dragTop,
            dragLeft = _props$crfFormEdit.dragLeft,
            dragHeight = _props$crfFormEdit.dragHeight,
            dragWidth = _props$crfFormEdit.dragWidth,
            onMove = _props$crfFormEdit.onMove,
            stopDrag = _props$crfFormEdit.stopDrag,
            dragFieldType = _props$crfFormEdit.dragFieldType;

        return React.createElement(
            'div',
            {
                className: 'crf-warpper',
                onMouseMove: function onMouseMove(e) {
                    return onMove(e);
                },
                onMouseUp: function onMouseUp(e) {
                    return stopDrag(e);
                }
            },
            React.createElement(_SideBar2.default, {
                loading: formsLoading,
                forms: forms,
                path: match.url,
                url: location.pathname
            }),
            React.createElement(
                'div',
                {
                    className: 'crf-container'
                },
                React.createElement(_reactRouterDom.Route, { path: '' + match.url, exact: true, component: _FormMainView2.default }),
                React.createElement(_reactRouterDom.Route, { path: match.url + '/:id', exact: true, component: _FormMainView2.default })
            ),
            React.createElement(_FormEdit2.default, null),
            React.createElement(_RelationView2.default, null),
            isDrag ? React.createElement(
                'div',
                {
                    style: {
                        position: 'absolute',
                        top: dragTop,
                        left: dragLeft,
                        width: dragWidth + 'px',
                        minHeight: dragHeight + 'px',
                        boxSizing: 'border-box',
                        backgroundColor: '#F4F4F4',
                        boxShadow: '2px 2px 8px rgba(160, 160, 160, .2)',
                        border: '1px solid #EEE'
                    }
                },
                React.createElement(_FieldView2.default, {
                    store: _FieldModel.mapType.getStore(dragFieldType),
                    SubView: _FieldModel.mapType.getView(dragFieldType),
                    disabled: true
                })
            ) : void 0
        );
    };

    return _class;
}(React.Component)));