'use strict';

exports.__esModule = true;

var _css = require('antd/lib/tooltip/style/css');

var _tooltip = require('antd/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _css2 = require('antd/lib/icon/style/css');

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _css3 = require('antd/lib/input/style/css');

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Search = _input2.default.Search;


var FormEdit = (0, _mobxReact.inject)('crfFormEdit')((0, _mobxReact.observer)(function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    _class.prototype.componentWillMount = function componentWillMount() {
        this.props.crfFormEdit.setFields();
    };

    _class.prototype.render = function render() {
        var _props$crfFormEdit = this.props.crfFormEdit,
            tabs = _props$crfFormEdit.tabs,
            activeTab = _props$crfFormEdit.activeTab,
            ActiveView = _props$crfFormEdit.ActiveView,
            changeTab = _props$crfFormEdit.changeTab,
            fieldTypes = _props$crfFormEdit.fieldTypes,
            startDrag = _props$crfFormEdit.startDrag;

        return React.createElement(
            'div',
            { className: 'crf-edit-view-content' },
            React.createElement(
                'div',
                {
                    className: 'edit-view-header'
                },
                React.createElement(
                    'ul',
                    null,
                    tabs.map(function (item, i) {
                        return React.createElement(
                            'li',
                            { key: i },
                            React.createElement(
                                _tooltip2.default,
                                {
                                    placement: 'bottom',
                                    title: item.name
                                },
                                React.createElement(
                                    'a',
                                    {
                                        className: item.type === activeTab ? 'active' : void 0,
                                        onClick: function onClick() {
                                            changeTab(item.type, item.view);
                                        }
                                    },
                                    React.createElement(_icon2.default, { type: item.icon })
                                )
                            )
                        );
                    })
                )
            ),
            React.createElement(
                'div',
                { className: 'edit-view-content' },
                React.createElement(
                    'div',
                    {
                        style: { width: '100%', height: '100%', overflow: 'auto' }
                    },
                    React.createElement(ActiveView, null)
                )
            ),
            React.createElement(
                'div',
                { className: 'edit-view-fields' },
                React.createElement(
                    'div',
                    {
                        className: 'edit-fields-header'
                    },
                    React.createElement(
                        'h4',
                        null,
                        '\u95EE\u9898\u7C7B\u578B'
                    )
                ),
                React.createElement(
                    'div',
                    { className: 'edit-fields-content' },
                    React.createElement(
                        'div',
                        {
                            style: { width: '100%', height: '100%', overflow: 'auto' }
                        },
                        React.createElement(
                            'ul',
                            null,
                            fieldTypes.map(function (item, i) {
                                return React.createElement(FieldTypeItem, _extends({}, item, {
                                    onDrag: startDrag,
                                    key: i,
                                    index: i
                                }));
                            })
                        )
                    )
                )
            ),
            React.createElement(
                'div',
                { className: 'edit-view-footer' },
                React.createElement(Search, {
                    placeholder: '\u8BF7\u8F93\u5165\u95EE\u9898\u7C7B\u578B'
                })
            )
        );
    };

    return _class;
}(React.Component)));

var FieldTypeItem = function (_React$Component2) {
    _inherits(FieldTypeItem, _React$Component2);

    function FieldTypeItem() {
        _classCallCheck(this, FieldTypeItem);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    FieldTypeItem.prototype.render = function render() {
        var _this3 = this;

        var _props = this.props,
            icon = _props.icon,
            title = _props.title,
            type = _props.type,
            note = _props.note,
            onDrag = _props.onDrag,
            draging = _props.draging,
            index = _props.index;

        return React.createElement(
            'li',
            {
                ref: function ref(_type) {
                    return _this3._type = _type;
                },
                style: draging ? { opacity: .4 } : void 0
            },
            React.createElement(
                'div',
                { className: 'field-content' },
                React.createElement(
                    'div',
                    { className: 'field-icon' },
                    React.createElement(
                        'span',
                        null,
                        React.createElement('i', { className: icon })
                    )
                ),
                React.createElement(
                    'div',
                    { className: 'field-title' },
                    React.createElement(
                        'p',
                        null,
                        React.createElement(
                            'span',
                            null,
                            title
                        ),
                        ' -',
                        note
                    )
                )
            ),
            React.createElement('div', {
                style: {
                    position: 'absolute',
                    width: '100%',
                    height: '100%',
                    top: 0,
                    left: 0,
                    cursor: 'pointer',
                    backgroundColor: 'rgba(0, 0, 0, 0)'
                },
                onMouseDown: function onMouseDown(e) {
                    onDrag(index, type, e, _this3._type);
                }
            })
        );
    };

    return FieldTypeItem;
}(React.Component);

;

exports.default = FormEdit;