'use strict';

exports.__esModule = true;

var _css = require('antd/lib/modal/style/css');

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _css2 = require('antd/lib/button/style/css');

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _css3 = require('antd/lib/icon/style/css');

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

var _FieldContent = require('./FieldContent');

var _FieldContent2 = _interopRequireDefault(_FieldContent);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormMainView = (0, _mobxReact.inject)('crfFormMain', 'crf', 'crfDesign')((0, _mobxReact.observer)(function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    _class.prototype.componentDidMount = function componentDidMount() {
        this.props.crfDesign.setMainElement(this._main);
    };

    _class.prototype.render = function render() {
        var _this2 = this;

        var _props$crfFormMain = this.props.crfFormMain,
            form = _props$crfFormMain.form,
            page = _props$crfFormMain.page,
            zoom = _props$crfFormMain.zoom,
            plusZoom = _props$crfFormMain.plusZoom,
            minuZoom = _props$crfFormMain.minuZoom,
            showPreview = _props$crfFormMain.showPreview,
            openPreview = _props$crfFormMain.openPreview,
            closePreview = _props$crfFormMain.closePreview,
            previewKey = _props$crfFormMain.previewKey;

        return React.createElement(
            'div',
            { style: { position: 'absolute', width: '100%', height: '100%' } },
            React.createElement(
                'div',
                { className: 'main-view-header' },
                React.createElement(
                    'h4',
                    null,
                    React.createElement(
                        'span',
                        null,
                        React.createElement(_icon2.default, { type: 'file-text' })
                    ),
                    form.name
                ),
                React.createElement(
                    'div',
                    { style: { display: 'table-cell', width: '50px' } },
                    React.createElement(
                        _button2.default,
                        {
                            size: 'small',
                            type: 'primary',
                            onClick: function onClick() {
                                return openPreview();
                            }
                        },
                        '\u9884\u89C8'
                    )
                )
            ),
            React.createElement(
                'div',
                { className: 'main-view-content' },
                React.createElement(
                    'div',
                    {
                        ref: function ref(main) {
                            return _this2._main = main;
                        },
                        style: { width: '100%', height: '100%', overflow: 'scroll' }
                    },
                    React.createElement(
                        'div',
                        { style: { width: page.width, padding: '24px 0', margin: '0 auto' } },
                        React.createElement(
                            'div',
                            { className: 'view-page', style: { width: page.width } },
                            React.createElement(
                                'div',
                                { style: { minHeight: page.height } },
                                React.createElement(_FieldContent2.default, {
                                    mode: 'DEV',
                                    width: page.width - 48,
                                    name: form.name
                                })
                            )
                        )
                    )
                )
            ),
            React.createElement(
                'div',
                { className: 'main-view-footer' },
                React.createElement(
                    'p',
                    null,
                    '\u5BBD\u9AD8\uFF1A',
                    page.width + ' x ' + page.height
                ),
                React.createElement(
                    'div',
                    { className: 'footer-btn-content' },
                    React.createElement(
                        'div',
                        { className: 'footer-btn-box' },
                        React.createElement(
                            'a',
                            {
                                onClick: function onClick() {
                                    return plusZoom();
                                }
                            },
                            React.createElement('i', { className: 'icon-plus3' })
                        ),
                        React.createElement(
                            'span',
                            null,
                            parseInt(zoom * 10) + '%'
                        ),
                        React.createElement(
                            'a',
                            {
                                onClick: function onClick() {
                                    return minuZoom();
                                }
                            },
                            React.createElement('i', { className: 'icon-minus3' })
                        )
                    )
                )
            ),
            React.createElement(
                _modal2.default,
                {
                    key: 'preview_' + previewKey,
                    visible: showPreview,
                    onCancel: function onCancel() {
                        return closePreview();
                    },
                    title: '\u8868\u5355\u9884\u89C8',
                    width: '900px',
                    style: { padding: 0, top: "10px" },
                    footer: null
                },
                React.createElement(
                    'div',
                    {
                        style: { margin: '0 -16px', height: window.document.body.clientHeight - 48 - 32 - 20 + 'px', overflow: 'auto' }
                    },
                    React.createElement(_FieldContent2.default, {
                        mode: 'PREVIEW',
                        width: page.width - 48,
                        name: form.name
                    })
                )
            )
        );
    };

    return _class;
}(React.Component)));

exports.default = FormMainView;