'use strict';

exports.__esModule = true;
exports.BaseFormModel = undefined;

var _mobx = require('mobx');

var _utils = require('../utils');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BaseFormModel = exports.BaseFormModel = function BaseFormModel() {
    var _this = this;

    _classCallCheck(this, BaseFormModel);

    (0, _mobx.extendObservable)(this, {
        change: false,
        saving: false,
        isChanged: (0, _mobx.action)(function () {
            _this.change = false;
        })
    });
    (0, _mobx.autorun)(function () {
        if (_this.change) {
            console.log('change');
            _this.isChanged();
        };
    });
};

;

var CRFFormModel = function (_BaseFormModel) {
    _inherits(CRFFormModel, _BaseFormModel);

    function CRFFormModel() {
        var _this3 = this;

        _classCallCheck(this, CRFFormModel);

        var _this2 = _possibleConstructorReturn(this, _BaseFormModel.call(this));

        (0, _mobx.extendObservable)(_this2, {
            forms: [],
            formsLoading: false,
            getForms: (0, _mobx.action)(function () {
                var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(api) {
                    var resp;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                            switch (_context.prev = _context.next) {
                                case 0:
                                    _this2.formsLoading = true;
                                    _context.next = 3;
                                    return api();

                                case 3:
                                    resp = _context.sent;

                                    _this2.formsLoading = false;
                                    _this2.forms = resp.data;
                                    // const _forms = [{
                                    //     id: "0",
                                    //     name: '基本信息'
                                    // },{
                                    //     id: '1',
                                    //     name: '入院查体'
                                    // },{
                                    //     id: '2',
                                    //     name: '实验室检查'
                                    // },{
                                    //     id: '3',
                                    //     name: '既往史'
                                    // }];
                                    //this.forms = _forms;

                                case 6:
                                case 'end':
                                    return _context.stop();
                            }
                        }
                    }, _callee, _this3);
                }));

                return function (_x) {
                    return _ref.apply(this, arguments);
                };
            }())
        });
        return _this2;
    }

    return CRFFormModel;
}(BaseFormModel);

;

var crf = new CRFFormModel();

exports.default = crf;