'use strict';

exports.__esModule = true;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _mobxReact = require('mobx-react');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RelationView = (0, _mobxReact.inject)('crfRelation', "crfDesign")((0, _mobxReact.observer)(function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    _class.prototype.componentWillMount = function componentWillMount() {
        this.props.crfRelation.listenCtrl();
    };

    _class.prototype.render = function render() {
        var showCanvas = this.props.crfRelation.showCanvas;

        return showCanvas ? React.createElement(
            'div',
            {
                style: {
                    position: 'absolute',
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0
                }
            },
            React.createElement(CanvasView, null)
        ) : null;
    };

    return _class;
}(React.Component)));

var CanvasView = (0, _mobxReact.inject)('crfRelation')((0, _mobxReact.observer)(function (_React$Component2) {
    _inherits(_class2, _React$Component2);

    function _class2(props) {
        _classCallCheck(this, _class2);

        var _this2 = _possibleConstructorReturn(this, _React$Component2.call(this, props));

        _this2.state = {
            wrap: {
                height: window.document.body.clientHeight,
                width: window.document.body.clientWidth
            }
        };
        return _this2;
    }

    _class2.prototype.componentDidMount = function componentDidMount() {
        var _this3 = this;

        this.props.crfRelation.setCanvasNode(this._canvas);
        window.onresize = function () {
            _this3.setState({ wrap: {
                    height: window.document.body.clientHeight,
                    width: window.document.body.clientWidth
                } });
        };
    };

    _class2.prototype.render = function render() {
        var _this4 = this;

        return React.createElement('canvas', {
            ref: function ref(canvas) {
                return _this4._canvas = canvas;
            },
            width: this.state.wrap.width,
            height: this.state.wrap.height
        });
    };

    return _class2;
}(React.Component)));

exports.default = RelationView;