'use strict';

exports.__esModule = true;

var _css = require('antd/lib/icon/style/css');

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _css2 = require('antd/lib/spin/style/css');

var _spin = require('antd/lib/spin');

var _spin2 = _interopRequireDefault(_spin);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactRouterDom = require('react-router-dom');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SideBar = function (_React$Component) {
    _inherits(SideBar, _React$Component);

    function SideBar() {
        _classCallCheck(this, SideBar);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    SideBar.prototype.render = function render() {
        var _props = this.props,
            forms = _props.forms,
            url = _props.url,
            path = _props.path,
            loading = _props.loading;

        return React.createElement(
            'div',
            { className: 'crf-sidebar' },
            React.createElement(
                'div',
                { className: 'sidebar-header' },
                React.createElement(
                    'h4',
                    null,
                    '\u8868\u5355\u5217\u8868'
                )
            ),
            React.createElement(
                _spin2.default,
                {
                    spinning: loading,
                    wrapperClassName: 'sidebar-content',
                    tip: '\u8868\u5355\u52A0\u8F7D\u4E2D',
                    delay: 100
                },
                React.createElement(
                    'div',
                    { style: { height: '100%', width: "100%", overflow: 'auto' } },
                    React.createElement(
                        'ul',
                        { style: { padding: '12px 0' } },
                        forms.map(function (item, i) {
                            return React.createElement(FormItem, _extends({}, item, {
                                url: path + '/' + item.id,
                                key: i,
                                active: path + '/' + item.id === url
                            }));
                        })
                    )
                )
            )
        );
    };

    return SideBar;
}(React.Component);

exports.default = SideBar;
;

var FormItem = function (_React$Component2) {
    _inherits(FormItem, _React$Component2);

    function FormItem() {
        _classCallCheck(this, FormItem);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    FormItem.prototype.render = function render() {
        var _props2 = this.props,
            active = _props2.active,
            name = _props2.name,
            id = _props2.id,
            url = _props2.url;

        var _children = React.createElement(
            _reactRouterDom.Link,
            {
                to: url
            },
            React.createElement(
                'span',
                null,
                React.createElement(_icon2.default, { type: 'file-text' })
            ),
            name
        );
        var _active = React.createElement(
            'a',
            {
                to: url
            },
            React.createElement(
                'span',
                null,
                React.createElement(_icon2.default, { type: 'file-text' })
            ),
            name
        );
        return React.createElement(
            'li',
            {
                className: active ? 'active' : void 0
            },
            active ? _active : _children
        );
    };

    return FormItem;
}(React.Component);

;