'use strict';

exports.__esModule = true;

var _css = require('antd/lib/modal/style/css');

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _css2 = require('antd/lib/spin/style/css');

var _spin = require('antd/lib/spin');

var _spin2 = _interopRequireDefault(_spin);

var _css3 = require('antd/lib/form/style/css');

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _BaseModel = require('./BaseModel');

var _BaseModel2 = _interopRequireDefault(_BaseModel);

var _FormModel = require('./form/FormModel');

var _FormModel2 = _interopRequireDefault(_FormModel);

var _mobxReact = require('mobx-react');

var _utils = require('./utils');

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var _Api = require('./Api');

var _Api2 = _interopRequireDefault(_Api);

var _FormModel3 = require('./CRFForm/FormModel');

var _FormModel4 = _interopRequireDefault(_FormModel3);

var _FormEditModel = require('./CRFForm/FormEditModel');

var _FormEditModel2 = _interopRequireDefault(_FormEditModel);

var _FormMainModel = require('./CRFForm/FormMainModel');

var _FormMainModel2 = _interopRequireDefault(_FormMainModel);

var _FieldDesignModel = require('./CRFForm/FieldDesignModel');

var _FieldDesignModel2 = _interopRequireDefault(_FieldDesignModel);

var _RelationModel = require('./CRFForm/RelationModel');

var _RelationModel2 = _interopRequireDefault(_RelationModel);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var App = function () {
    var _models = {
        crf: _FormModel4.default,
        crfFormEdit: _FormEditModel2.default,
        crfFormMain: _FormMainModel2.default,
        crfDesign: _FieldDesignModel2.default,
        crfRelation: _RelationModel2.default
    };
    return function () {
        function _class() {
            _classCallCheck(this, _class);
        }

        _class.prototype.model = function model(_config) {
            var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';

            try {
                var namespace = _config.namespace;

                if ((0, _utils.isEmpty)(namespace)) {
                    throw new Error('请为model输入正确的命名');
                };
                switch (type) {
                    case 'default':
                        _models[namespace] = new _BaseModel2.default(_config);
                        break;
                    case 'form':
                        _models[namespace] = new _FormModel2.default(_config);
                        break;
                    default:
                        _models[namespace] = new _BaseModel2.default(_config);
                        break;
                };
            } catch (error) {
                throw new Error(error);
            };
        };

        _class.prototype.api = function api(config) {
            this.http = new _Api2.default(config);
        };

        _class.prototype.view = function view() {
            for (var _len = arguments.length, injectName = Array(_len), _key = 0; _key < _len; _key++) {
                injectName[_key] = arguments[_key];
            }

            if ((0, _utils.isEmpty)(injectName)) {
                throw new Error('view方法参数不能为空');
            };
            if (!(0, _utils.isString)(injectName[0])) {
                return injectName[0];
            };
            return function (render) {
                return _mobxReact.inject.apply(undefined, injectName)((0, _mobxReact.observer)(render));
            };
        };

        _class.prototype.formview = function formview() {
            var _this = this;

            var formModel = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
            var injectName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

            injectName.push(formModel);
            return function (Render) {
                return _form2.default.create({
                    onValuesChange: function onValuesChange(props, values) {
                        _models[formModel]['changeValue'](values);
                    }
                })(_this.view.apply(_this, injectName)(function (props) {
                    return React.createElement(
                        _form2.default,
                        {
                            layout: props.layout,
                            hideRequiredMark: props.hideRequiredMark,
                            style: Object.assign({}, { padding: '30px 0' }, props.style),
                            onSubmit: function onSubmit(e) {
                                return _models[formModel].onSubmit(e, props.form);
                            }
                        },
                        React.createElement(Render, props),
                        React.createElement(
                            _modal2.default,
                            {
                                footer: null,
                                closable: false,
                                visible: props[formModel]['showSubmitting'] && props[formModel]['submitting']
                            },
                            React.createElement(
                                'div',
                                { style: { padding: '20px 12px' } },
                                React.createElement(_spin2.default, { size: 'small' }),
                                React.createElement(
                                    'span',
                                    { style: { marginLeft: '12px', fontSize: '14px' } },
                                    '\u8868\u5355\u63D0\u4EA4\u4E2D,\u8BF7\u4E0D\u8981\u5173\u95ED\u7A97\u53E3!'
                                )
                            )
                        )
                    );
                }));
            };
        };

        _class.prototype.router = function router(Router) {
            this.Router = React.createElement(
                _mobxReact.Provider,
                _extends({}, _models, { api: this.http }),
                React.createElement(Router, null)
            );
        };

        _class.prototype.run = function run(node) {
            var Router = this.Router;

            (0, _reactDom.render)(Router, document.getElementById(node));
        };

        return _class;
    }();
}();

var app = new App();

exports.default = app;