'use strict';

exports.__esModule = true;

var _mobx = require('mobx');

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormModel = function (_BaseModel) {
    _inherits(FormModel, _BaseModel);

    function FormModel(_configs) {
        var _this2 = this;

        var _this;

        _classCallCheck(this, FormModel);

        _configs['formData'] = {};
        _configs['submitting'] = false;
        if (!('showSubmitting' in _configs)) {
            _configs['showSubmitting'] = true;
        };
        var _actions = {};
        if ('actions' in _configs) {
            _actions = _configs['actions'];
        };
        _actions['onSubmit'] = function (event, form) {
            event.preventDefault();
            form.validateFields(function () {
                var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(err, values) {
                    var resp;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                            switch (_context.prev = _context.next) {
                                case 0:
                                    if (err) {
                                        _context.next = 12;
                                        break;
                                    }

                                    if (_this.beforeSubmit) {
                                        _this.beforeSubmit(values);
                                    };
                                    _this.submitting = true;
                                    _context.next = 6;
                                    return _app2.default.http[_this.api](values);

                                case 6:
                                    resp = _context.sent;

                                    if (_this.afterSubmit && resp) {
                                        _this.afterSubmit(resp.data);
                                    };
                                    _this.submitting = false;
                                    _context.next = 13;
                                    break;

                                case 12:
                                    _this.localError(err, values);

                                case 13:
                                    ;

                                case 14:
                                case 'end':
                                    return _context.stop();
                            }
                        }
                    }, _callee, _this2);
                }));

                return function (_x, _x2) {
                    return _ref.apply(this, arguments);
                };
            }());
        };
        _actions['changeValue'] = function (values) {
            _this.formData = Object.assign({}, _this.formData, values);
        };
        _configs.actions = _actions;
        return _this = _possibleConstructorReturn(this, _BaseModel.call(this, _configs));
    }

    return FormModel;
}(_BaseModel3.default);

;

exports.default = FormModel;