'use strict';

exports.__esModule = true;
exports.SubmitBtn = exports.FormSelect = exports.Text = undefined;

var _css = require('antd/lib/button/style/css');

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _css2 = require('antd/lib/input/style/css');

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _css3 = require('antd/lib/select/style/css');

var _select = require('antd/lib/select');

var _select2 = _interopRequireDefault(_select);

var _css4 = require('antd/lib/form/style/css');

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _react = require('react');

var React = _interopRequireWildcard(_react);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _form2.default.Item;
var SelectOption = _select2.default.Option;

function relation() {
    var getFieldsValue = this.props.form.getFieldsValue;

    var value = getFieldsValue();
    var rel = this.props.relation;
    if (rel) {
        var _r = void 0;
        for (var _iterator = new Map(rel.map(function (item, i) {
            return [i, item];
        })), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
            var _ref2;

            if (_isArray) {
                if (_i >= _iterator.length) break;
                _ref2 = _iterator[_i++];
            } else {
                _i = _iterator.next();
                if (_i.done) break;
                _ref2 = _i.value;
            }

            var _ref = _ref2;
            var i = _ref[0];
            var item = _ref[1];

            var _rel = void 0;
            switch (item['exist']) {
                case 'is':
                    _rel = value[item["name"]] === item['value'];
                    break;
                case 'isnot':
                    _rel = value[item["name"]] !== item['value'];
                    break;
            };
            if (i === 0) {
                _r = _rel;
                continue;
            };
            switch (item['rel']) {
                case 'and':
                    _r = _r && _rel;
                    break;
                case 'or':
                    _r = _r || _rel;
                    break;
            };
        };
        return _r;
    };
    return true;
}

function formview(Element) {
    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _props = this.props,
        required = _props.required,
        label = _props.label,
        validate = _props.validate,
        inputType = _props.inputType;

    var rules = [{
        required: required ? true : false,
        message: label + '\u4E0D\u80FD\u4E3A\u7A7A\uFF01'
    }];
    if (validate) {
        rules.push({
            validator: function validator(rule, value, cb) {
                var _val = validates[validate](value, label);
                if (!_val.pattern && value) {
                    cb(new Error(_val.message));
                } else {
                    cb();
                };
            }
        });
    };
    return React.createElement(
        FormItem,
        {
            labelCol: { span: 6 },
            wrapperCol: { span: 14 },
            label: this.props.label
        },
        getFieldDecorator(this.props.name, {
            initialValue: this.props.value,
            rules: rules
        })(Element)
    );
};

var Text = exports.Text = function (_React$Component) {
    _inherits(Text, _React$Component);

    function Text() {
        _classCallCheck(this, Text);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    Text.prototype.render = function render() {
        return relation.apply(this) ? formview.apply(this, [React.createElement(_input2.default, {
            disabled: this.props.disabled,
            type: this.props.type ? this.props.type : "text",
            rows: '4',
            placeholder: this.props.placeholder
        })]) : null;
    };

    return Text;
}(React.Component);

;

var FormSelect = exports.FormSelect = function (_React$Component2) {
    _inherits(FormSelect, _React$Component2);

    function FormSelect() {
        _classCallCheck(this, FormSelect);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    FormSelect.prototype.getOptions = function getOptions() {
        var options = this.props.options;

        return options.map(function (item, i) {
            return React.createElement(
                SelectOption,
                { key: item.value },
                item.label
            );
        });
    };

    FormSelect.prototype.render = function render() {
        return relation.apply(this) ? formview.apply(this, [React.createElement(
            _select2.default,
            {
                disabled: this.props.disabled,
                placeholder: this.props.placeholder
            },
            this.getOptions()
        )]) : null;
    };

    return FormSelect;
}(React.Component);

;

var SubmitBtn = exports.SubmitBtn = function (_React$Component3) {
    _inherits(SubmitBtn, _React$Component3);

    function SubmitBtn() {
        _classCallCheck(this, SubmitBtn);

        return _possibleConstructorReturn(this, _React$Component3.apply(this, arguments));
    }

    SubmitBtn.prototype.render = function render() {
        return React.createElement(
            FormItem,
            {
                wrapperCol: { span: 14, offset: 6 }
            },
            React.createElement(
                _button2.default,
                { type: 'primary', htmlType: 'submit' },
                this.props.label || '提交'
            )
        );
    };

    return SubmitBtn;
}(React.Component);

;