import { observable, action, extendObservable } from 'mobx';
import qs from 'qs';
import { isEmpty } from './utils'

const BaseModel = (function(){
    return class {
        constructor( _config ){
            let _options = { };
            for( let key in _config ){
                if( key === 'namespace' ){
                    continue;    
                };
                if( key === 'actions' ){
                    if( isEmpty(_config[key]) ){
                        continue;
                    };
                    for( let _action in _config[key] ){
                        _options[_action] = action((...args) => _config[key][_action].apply(this, [...args]));
                    };
                    continue;
                };
                _options[key] = _config[key];
            };
            
            extendObservable(this, _options)
        };

        getQuery(){
            const _search = window.location.search;
            if( !/^\?/.test(_search) ){
                return void 0
            }
            const _queryString = _search.split('?')[1]
            return qs.parse(_queryString)
        };

    };
})()

export default BaseModel