import * as React from 'react';
import { inject, observer } from 'mobx-react';
import { InputWarp } from './DesignComponents';
import { ChromePicker } from 'react-color';
import { 
    Input, 
    Select,
    Button,
    Popover,
    Switch
} from 'antd';

export class AddFieldView extends React.Component {
    render(){
        return (
            <div>AddField</div>
        );
    };
};

export const LayoutsView = inject('crfDesign')(observer(class extends React.Component {
    render(){
        const {
            formName,
            changeFormName,
            headerStyle,
            changeHeaderStyle,
            fontSizeOptions,
            fontWeightOptions,
            textAlignOptions,
            //design,
            //addRow,
            //deleteRow,
            addCell,
            fieldName,
            border,
            changeBorder,
        } = this.props.crfDesign
        return (
            <div className='layouts-content' >
                <div
                    style={{ width: '100%', height: '100%', overflow: 'auto' }}
                >
                    <div className='layouts-header-content' >
                        <div className='design-header' >
                            <h4>表头设计</h4>
                        </div>
                        <div>
                            <InputWarp
                                label='标题'
                            >
                                <Input 
                                    value={ formName }
                                    onChange={e => {
                                        const { value } = e.target;
                                        changeFormName( value );
                                    }}
                                />
                            </InputWarp>
                            <InputWarp
                                label='位置'
                            >
                                <Select
                                    style={{ width: '100%' }}
                                    value={ headerStyle.textAlign }
                                    onChange={value => changeHeaderStyle({ textAlign: value })}
                                >
                                {
                                    textAlignOptions.map((item) => (
                                        <Select.Option key={ item.value }>{ item.label }</Select.Option>
                                    ))
                                }
                                </Select>
                            </InputWarp>
                            <InputWarp
                                label='字号'
                            >
                                <Select
                                    style={{ width: '100%' }}
                                    value={ headerStyle.fontSize }
                                    onChange={value => changeHeaderStyle({ fontSize: value })}
                                >
                                {
                                    fontSizeOptions.map((item) => (
                                        <Select.Option key={ item + 'px' }>{ item + 'px' }</Select.Option>
                                    ))
                                }
                                </Select>
                            </InputWarp>
                            <InputWarp
                                label='加粗'
                            >
                                <Select
                                    style={{ width: '100%' }}
                                    value={ headerStyle.fontWeight }
                                    onChange={value => changeHeaderStyle({ fontWeight: value })}
                                >
                                {
                                    fontWeightOptions.map((item) => (
                                        <Select.Option key={ item }>{ item }</Select.Option>
                                    ))
                                }
                                </Select>
                            </InputWarp>
                        </div>
                    </div>
                    <div className='layouts-header-content'>
                        <div className='design-header' >
                            <h4>布局设计</h4>
                        </div>
                        <div>
                            <InputWarp
                                //label='添加'
                            >
                                <Button
                                    type='primary'
                                    onClick={() => addCell()}
                                >添加布局元素</Button>
                            </InputWarp>
                        </div>
                        {/*
                        <div 
                            style={{
                                wdith: '100%',
                                backgroundColor: '#fff',
                                borderRadius: "2px",
                                marginTop: '8px'
                            }}
                        >
                            <FormViewDesign
                                data={ design }
                                addNode={ addRow }
                                deleteNode={ deleteRow }
                            />
                        </div>
                        */}
                    </div>
                    <div className='layouts-header-content' style={{ borderBottom: '0 none' }}>
                        <div className='design-header' >
                            <h4>边框设计</h4>
                        </div>
                        <InputWarp
                            label='是否显示'
                        >
                            <Switch 
                                checked={ border.show}
                                onChange={checked => changeBorder({ show: checked })}
                                checkedChildren='是'
                                unCheckedChildren='否'
                            />
                        </InputWarp>
                        <InputWarp
                            label='颜色'
                        >
                            <Popover
                                placement='bottom'
                                trigger='click'
                                overlayClassName='crf-color-picker-content'
                                content={(
                                    <ChromePicker 
                                        color={ border.color }
                                        onChange={({hex})=> changeBorder({color: hex}) }
                                    />
                                )}
                            >
                                <div style={{ width: '104px', border:'1px solid #ddd',backgroundColor: '#fff', padding: '4px', borderRadius: '2px' }}>
                                    <div style={{ height: '12px', backgroundColor: border.color }} ></div>
                                </div>
                            </Popover>
                        </InputWarp>
                    </div>
                </div>
            </div>
        );
    };
}));

export class BaseView extends React.Component {
    render(){
        return (
            <div>Base</div>
        );
    };
};

export class MateFieldsView extends React.Component {
    render(){
        return (
            <div>MateFields</div>
        );
    };
};

export class MateView extends React.Component {
    render(){
        return (
            <div>Mate</div>
        );
    };
};