import { extendObservable, action } from 'mobx';
import crfDesign from './FieldDesignModel';

class FormMain {
    constructor(){
        extendObservable(this, {
            form: {
                name: '基本信息',
                id: 0,
                code: '',
                version: 0
            },
            zoom: 10,
            showPreview: false,
            previewKey: 0,
            get page(){
                return{
                    width: this.zoom * 768 / 10,
                    height: this. zoom * 1024 / 10
                }
            },
            init: action(function( id ){
                
            }),
            plusZoom: action(() => {
                this.zoom = Math.round(this.zoom + 2)
            }),
            minuZoom: action(() => {
                this.zoom = Math.round(this.zoom - 2)
            }),
            openPreview: action(() => {
                this.showPreview = true;
            }),
            closePreview: action(() => {
                crfDesign.clearFieldValue();
                this.showPreview = false;
                this.previewKey ++;
            })
        });
    };
};

const crfFormMain = new FormMain();

export default crfFormMain