import { extendObservable, action, autorun } from 'mobx';
import { isEmpty } from '../utils';

export class BaseFormModel {
    constructor(){
        extendObservable(this, {
            change: false,
            saving: false,
            isChanged: action(() => {
                this.change = false;
            })
        });
        autorun(() => {
            if( this.change ){
                console.log( 'change' );
                this.isChanged();
            };
        });
    };
};
class CRFFormModel extends BaseFormModel {
   constructor(){
       super();
       extendObservable(this,{
           forms: [],
           formsLoading: false,
           getForms: action(async ( api ) => {
                this.formsLoading = true;
                const resp = await api();
                this.formsLoading = false;
                this.forms = resp.data
                // const _forms = [{
                //     id: "0",
                //     name: '基本信息'
                // },{
                //     id: '1',
                //     name: '入院查体'
                // },{
                //     id: '2',
                //     name: '实验室检查'
                // },{
                //     id: '3',
                //     name: '既往史'
                // }];
                //this.forms = _forms;
           })
       });
   };
};

const crf = new CRFFormModel();

export default crf;