import { extendObservable, action, autorun } from 'mobx';

class RelationModel {
    constructor(){
        extendObservable(this, {
            showAddexpendModal: false,
            ctrl: false,
            ctx: null,
            showCanvas: false,
            setCanvasNode: action((_node) => {
                const ctx = _node.getContext('2d');
                this.ctx = ctx;
            }),
            changeShowCanvas: action(() => {
                this.showCanvas = !this.showCanvas
            }),
            listenCtrl: action(() => {
                document.onkeydown = e => {
                    if( e.keyCode === 91 ){
                        this.ctrl = true;
                    };
                };
                document.onkeyup = e => {
                    this.ctrl = false;
                };
            })
        })
    }
};

const crfRealtion = new RelationModel();

export default crfRealtion;