import * as React from 'react';
import { inject, observer } from 'mobx-react';

const RelationView = inject('crfRelation', "crfDesign")(observer(class extends React.Component{

    componentWillMount(){
        this.props.crfRelation.listenCtrl( )
    }

    render(){
        const {
            showCanvas
        } = this.props.crfRelation;
        return (
            showCanvas
            ?   <div
                    style={{
                        position: 'absolute',
                        top: 0,
                        left: 0,
                        right: 0,
                        bottom: 0
                    }}
                >
                    <CanvasView />
                </div>
            : null
        );
    }
}));

const CanvasView = inject('crfRelation')(observer(class extends React.Component{
    constructor(props){
        super(props);
        this.state = {
            wrap: {
                height: window.document.body.clientHeight,
                width: window.document.body.clientWidth
            }
        };
    }

    componentDidMount(){
        this.props.crfRelation.setCanvasNode(this._canvas)
        window.onresize = () => {
            this.setState({wrap: {
                height: window.document.body.clientHeight,
                width: window.document.body.clientWidth
            }});
        };
    }

    render(){
        return (
            <canvas
                ref={canvas => this._canvas = canvas}
                width={ this.state.wrap.width }
                height={ this.state.wrap.height }
            ></canvas>
        );
    }
}));

export default RelationView;