import * as React from 'react';
import { Icon, Spin } from 'antd';
import { Link } from 'react-router-dom';

export default class SideBar extends React.Component{
    render(){
        const { 
            forms,
            url,
            path,
            loading
        } = this.props;
        return (
            <div className='crf-sidebar' >
                <div className='sidebar-header'>
                    <h4>表单列表</h4>
                </div>
                <Spin
                    spinning = { loading }
                    wrapperClassName='sidebar-content'
                    tip='表单加载中'
                    delay = { 100 }
                >
                    <div style={{height: '100%', width: "100%", overflow:'auto'}}>
                        <ul style={{padding: '12px 0' }}>
                        {
                            forms.map((item, i) => (
                                <FormItem 
                                    { ...item } 
                                    url={ `${path}/${item.id}` } 
                                    key={ i } 
                                    active={ `${path}/${item.id}` === url } 
                                />
                            ))
                        }
                        </ul>
                    </div>
                </Spin>
            </div>
        );
    };
};

class FormItem extends React.Component {
    render(){
        const {
            active,
            name,
            id,
            url
        } = this.props;
        const _children = (
            <Link
                to={ url }
            >
                <span>
                    <Icon type="file-text" />
                </span>
                { name }
            </Link>
        );
        const _active = (
            <a
                to={ url }
            >
                <span>
                    <Icon type="file-text" />
                </span>
                { name }
            </a>
        );
        return (
            <li 
                className={ active ? 'active' : void 0 }
            >
            {
                active
                ?   _active
                :   _children
            }
            </li>
        );
    };
};