import * as React from 'react';
import { 
    Form,
    Input,
    Select,
    Button 
} from 'antd';

const FormItem = Form.Item;
const SelectOption = Select.Option

function relation(){
    const { getFieldsValue } = this.props.form;
    const value = getFieldsValue();
    const rel = this.props.relation;
    if( rel ){
        let _r;
        for( const [i,item] of new Map( rel.map(( item,i )=>[ i, item ]) ) ){
            let _rel;
            switch( item['exist'] ){
                case 'is':
                    _rel = value[ item["name"] ] === item['value'];
                    break;
                case 'isnot':
                    _rel = value[ item["name"] ] !== item['value'];
                    break;
            };
            if( i === 0 ){
                _r = _rel;
                continue;
            };
            switch( item['rel'] ){
                case 'and':
                    _r = _r && _rel;
                    break;
                case 'or':
                    _r = _r || _rel;
                    break;
            };
        };
        return _r;
    };
    return true;
}

function formview(Element) {
    const { getFieldDecorator } = this.props.form;
    const { required, label, validate, inputType } = this.props;
    let rules = [{
        required: required ? true : false,
        message: `${ label }不能为空！`
    }];
    if( validate ){
        rules.push({
            validator( rule, value, cb ){
                const _val = validates[ validate ]( value, label );
                if( !_val.pattern && value ){
                    cb( new Error( _val.message ) );
                }else{
                    cb( );
                };
            }
        });
    };
    return (
        <FormItem
            labelCol = {{ span: 6 }}
            wrapperCol = {{ span: 14 }}
            label = { this.props.label }
        >
            {getFieldDecorator(this.props.name, {
                initialValue: this.props.value,
                rules
            })(
               Element
            )}
        </FormItem>
    );
};

export class Text extends React.Component{
    render(){
        return relation.apply(this) 
        ?   formview.apply(this, [
                (
                    <Input
                        disabled = { this.props.disabled }
                        type={ this.props.type ? this.props.type : "text"} 
                        rows="4"
                        placeholder={ this.props.placeholder } 
                    />
                )
            ])
        : null
    }
};

export class FormSelect extends React.Component{
    getOptions(){
        const { options } = this.props;
        return options.map((item, i) => (
            <SelectOption key={item.value} >{ item.label }</SelectOption>
        ))
    }
    render(){
        return relation.apply(this)
        ?   formview.apply(this,[(
            <Select  
                disabled = { this.props.disabled }
                placeholder={ this.props.placeholder }
            >{this.getOptions()}</Select>
        )])
        : null
    }
};

export class SubmitBtn extends React.Component{
    render(){
        return (
            <FormItem
                wrapperCol={{ span: 14, offset: 6 }}
            >
                <Button type='primary' htmlType="submit" >{ this.props.label || '提交' }</Button>
            </FormItem>
        )
    };
};